'ＭＫ型およびＭＣＫ型の振動応答計算実行ﾌﾟﾛｸﾞﾗﾑ
Imports System.Drawing

Public Class BarsVRCal3
    Inherits System.Windows.Forms.Form

#Region " Windows フォーム デザイナで生成されたコード "

    Public Sub New()
        MyBase.New()

        ' この呼び出しは Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後に初期化を追加します。

    End Sub

    ' Form は dispose をオーバーライドしてコンポーネント一覧を消去します。
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows フォーム デザイナで必要です。
    Private components As System.ComponentModel.IContainer

    ' メモ : 以下のプロシージャは、Windows フォーム デザイナで必要です。
    ' Windows フォーム デザイナを使って変更してください。  
    ' コード エディタは使用しないでください。
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents PictureBox2 As System.Windows.Forms.PictureBox
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents ProgressBar1 As System.Windows.Forms.ProgressBar
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.PictureBox2 = New System.Windows.Forms.PictureBox()
        Me.PictureBox1 = New System.Windows.Forms.PictureBox()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.ProgressBar1 = New System.Windows.Forms.ProgressBar()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Label1.Location = New System.Drawing.Point(152, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(200, 24)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "振動応答計算の実行"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(24, 56)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(256, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Label2"
        '
        'PictureBox2
        '
        Me.PictureBox2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox2.Location = New System.Drawing.Point(112, 200)
        Me.PictureBox2.Name = "PictureBox2"
        Me.PictureBox2.Size = New System.Drawing.Size(184, 24)
        Me.PictureBox2.TabIndex = 3
        Me.PictureBox2.TabStop = False
        '
        'PictureBox1
        '
        Me.PictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox1.Location = New System.Drawing.Point(112, 144)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(248, 24)
        Me.PictureBox1.TabIndex = 4
        Me.PictureBox1.TabStop = False
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(48, 96)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(176, 16)
        Me.Label3.TabIndex = 5
        Me.Label3.Text = "Label3"
        '
        'ProgressBar1
        '
        Me.ProgressBar1.Location = New System.Drawing.Point(56, 256)
        Me.ProgressBar1.Name = "ProgressBar1"
        Me.ProgressBar1.Size = New System.Drawing.Size(384, 24)
        Me.ProgressBar1.TabIndex = 6
        '
        'BarsVRCal3
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.ClientSize = New System.Drawing.Size(496, 302)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.ProgressBar1, Me.Label3, Me.PictureBox1, Me.PictureBox2, Me.Label2, Me.Label1})
        Me.Name = "BarsVRCal3"
        Me.Text = "BarsVRCal3"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Dim SwK As IO.StreamWriter      '結果出力用

    Dim KindTime As Integer         '丸め区分（0:1以上、1:1未満）
    Dim KVibOff As Integer          '加振解除の有無（0:なし、1:有り）
    Dim Mband As Integer            'ﾊﾞﾝﾄﾞ幅（ﾊｰﾌ）
    Dim NbTime As Integer           '計算時間の丸め位置の桁数
    Dim NumEff As Integer           'FEM行列（右上三角）のｲﾝﾃﾞｯｸｽ数
    Dim NumEff0 As Integer          'FEM行列（右上三角）の初期ｲﾝﾃﾞｯｸｽ数

    Dim Beta As Single              'NewMark法の係数β
    Dim Cmax As Single              'Ｃ行列要素の最大値
    Dim Crate As Single         	'混合要素におけるﾗｰﾒﾝ要素追加微小比
    Dim DeltaMax As Single          '最大変位（絶対値）
    Dim DeltaMaxb As Single         '前ｻｲｸﾙの最大変位（絶対値）
    Dim RKmax As Single             'Ｋ行列要素の最大値
    Dim RMmax As Single             'Ｍ行列要素の最大値

    Dim Idiag() As Integer          '元のFEM行列対角の保存ｲﾝﾃﾞｯｸｽ番号
    Dim Idiag0() As Integer         '元のFEM行列対角の初期保存ｲﾝﾃﾞｯｸｽ番号
    Dim KAccSet() As Integer        '縮小行列変数の加速度設定有無
    Dim KcheckP() As Integer        '縮小行列変数のﾁｪｯｸ除外有無
    Dim Kcomp() As Integer          '元ﾃﾞｰﾀ節点の計算順序番号
    Dim KCLvib() As Integer         '各振動荷重の計算変数番号 
    Dim KDispMax(3) As Integer      '最大変位の節点番号
    Dim KDispSet() As Integer       '縮小行列変数の変位設定有無
    Dim KFLvibMax(3) As Integer     '最大振動外力の節点番号
    Dim KEfmax(8) As Integer        '応力・軸力等最大の要素番号
    Dim KEfmin(8) As Integer        '応力・軸力等最小の要素番号
    Dim KPfmax(8) As Integer        '応力・軸力等最大の節点番号
    Dim KPfmin(8) As Integer        '応力・軸力等最小の節点番号
    Dim KRcomp() As Integer         '計算順序節点の元ﾃﾞｰﾀ節点順序
    Dim Lcomp() As Integer      	'元全体行列変数の縮小行列変数への対応
    Dim Lr() As Integer             '元ﾃﾞｰﾀ節点の第1変数の全体ﾏﾄﾘｯｸｽ番号
    Dim NvarP() As Integer          '各節点順の変数の数

    Dim Accel0() As Single          '節点加速度の初期値
    Dim Accel1(), Accel2() As Single    '節点加速度
    Dim BarForce(,) As Single       '部材の軸力
    Dim BarShear(,) As Single       '部材の剪断力
    Dim BarMoment(,) As Single      '部材のﾓｰﾒﾝﾄ
    Dim Cmatb() As Single           'Ｃ行列（比例減衰の場合）
    Dim Disp0() As Single           '節点変位の初期値
    Dim Disp1(), Disp2() As Single  '節点変位
    Dim DispMax(3) As Single        '最大変位
    Dim EForce(), Efb() As Single   '要素の軸力等の配列
    Dim Ek(,), Ekb(,) As Single     '要素計算の２次配列
    Dim Em(,), Emb(,) As Single     '要素の質量ﾏﾄﾘｯｸｽ計算の配列
    Dim Fdirect(,) As Single        '拘束節点の荷重
    Dim FdirOut(,) As Single        '拘束節点の反力
    Dim FLoadVib(,) As Single       '節点振動外力の各軸方向の値
    Dim FLoadVibI(,) As Single      '節点振動外力の各軸方向の開始値
    Dim FLoadVibX(,) As Single      '節点振動外力の各軸方向の使用値
    Dim FLvibMax(3) As Single       '最大振動外力
    Dim RKmatb() As Single          'Ｋ行列
    Dim RMmatb() As Single          'Ｍ行列
    Dim TDispMax(3) As Single       '最大変位の時刻
    Dim TFLvibMax(3) As Single      '最大振動外力の時刻
    Dim Tfmax(8) As Single          '応力・軸力等の最大の時刻
    Dim Tfmin(8) As Single          '応力・軸力等の最小の時刻
    Dim TfD() As Double             '右辺ベクトル
    Dim TfS() As Single             '静解析の変位
    Dim Tk() As Double              'FEM行列
    Dim Trans(,) As Single          '座標変換ﾏﾄﾘｯｸｽ
    Dim Vel0() As Single            '節点速度の初期値
    Dim Vel1(), Vel2() As Single    '節点速度
    Dim Zfmax(8) As Single          '応力・軸力等の最大値
    Dim Zfmin(8) As Single          '応力・軸力等の最小値

    Private Sub AccelCalc(ByVal mh As Integer)
        '加速度の計算
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim i, ib, k, k2 As Integer
        Dim b1, b2, c1, ub As Double

        If KindVEqua = 1 Then
            c1 = 0.5 * DTime
            If KindDamp = 1 And Ndamp = 0 Then
                For i = 1 To Norder
                    b1 = Cmatb(Idiag(i)) * (Vel1(i) + c1 * Accel1(i))
                    TfD(i) = TfD(i) - b1
                Next i
            Else
                For i = 1 To Norder
                    b1 = 0
                    For k = Idiag(i - 1) + 1 To Idiag(i)
                        ib = i - (Idiag(i) - k)
                        b1 = b1 + Cmatb(k) * (Vel1(ib) + c1 * Accel1(ib))
                    Next k
                    If i < Norder Then
                        k2 = i + mh - 1
                        If k2 > Norder Then
                            k2 = Norder
                        End If
                        For k = i + 1 To k2
                            ib = Idiag(k) - k + i
                            If ib > Idiag(k - 1) Then
                                b1 = b1 + Cmatb(ib) * (Vel1(k) + c1 * Accel1(k))
                            End If
                        Next k
                    End If
                    TfD(i) = TfD(i) - b1
                Next i
            End If
        End If

        c1 = (0.5 - Beta) * DTime * DTime
        For i = 1 To Norder
            b1 = 0
            For k = Idiag(i - 1) + 1 To Idiag(i)
                ib = i - (Idiag(i) - k)
                b2 = Disp1(ib) + DTime * Vel1(ib) + c1 * Accel1(ib)
                b1 = b1 + RKmatb(k) * b2
            Next k
            If i < Norder Then
                k2 = i + mh - 1
                If k2 > Norder Then
                    k2 = Norder
                End If
                For k = i + 1 To k2
                    ib = Idiag(k) - k + i
                    If ib > Idiag(k - 1) Then
                        b2 = Disp1(k) + DTime * Vel1(k) + c1 * Accel1(k)
                        b1 = b1 + RKmatb(ib) * b2
                    End If
                Next k
            End If
            TfD(i) = TfD(i) - b1
        Next i

        Call TKmatSet() 'TK行列設定

        If KindLvib = 1 And KVibOff = 0 Then
            For i = 1 To NLvib
                k = KCLvib(i)
                ub = Accel2(k)
                Call RestCond(k, Mband, Norder, ub)   '拘束条件処理
            Next i
        End If

        Call Solver1(Norder)  'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ1（LDL分解）

        Call Solver2(Mband, Norder)  'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ2（前進・後退処理）

        For i = 1 To Norder
            If KAccSet(i) = 0 Then
                Accel2(i) = TfD(i)
            End If
        Next i

    End Sub

    Private Sub AccelInit(ByVal mh As Integer)
        '初期加速度の計算
        'mh･･･ﾊﾞﾝﾄﾞ幅
        Dim i As Integer

        For i = 1 To NumEff
            Tk(i) = RMmatb(i)
        Next i
        Call Solver1(Norder)  'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ1（LDL分解）
        Call Solver2(mh, Norder)  'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ2（前進・後退処理）

        For i = 1 To Norder
            Accel2(i) = TfD(i)
        Next i

    End Sub

    Private Sub AccelPointSet()
        '加速度加振点の設定
        Dim ib, ii, ix, jx, k, na, nb As Integer
        ReDim KCLvib(NLvib)

        nb = 0
        For ix = 1 To NPvib
            If Ntype < 3 Then
                ii = Ndim * (KPvib(ix) - 1)
                na = Ndim
            Else
                ib = KPvib(ix)
                ii = LrD(ib) - 1
                na = NvarPD(ib)
            End If
            For jx = 1 To na
                If JLoadVib(ix, jx) > 0 Then
                    k = Lcomp(ii + jx)
                    If k > 0 Then
                        nb = nb + 1
                        KCLvib(nb) = k
                    End If
                End If
            Next jx
        Next ix

    End Sub

    Sub BandWidth2(ByRef mb As Integer, ByVal kcbuf() As Integer)
        'ﾊﾞﾝﾄﾞ幅の計算
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'kcbuf()･･･元の節点の変数順序
        Dim i, ie, j, k, k1, k2, mx As Integer

        mx = 0
        For ie = 1 To Nelem
            i = NNelem(ie, 1)
            j = NNelem(ie, 2)
            k = Math.Abs(kcbuf(i) - kcbuf(j))
            If k > mx Then
                mx = k
            End If
        Next ie
        If Nspring > 0 Then
            For j = 1 To Nspring
                k1 = KPspring(j, 1)
                k2 = KPspring(j, 2)
                If k2 > 0 Then
                    k = Math.Abs(kcbuf(k1) - kcbuf(k2))
                    If k > mx Then mx = k
                End If
            Next j
        End If
        If Ndamp > 0 Then
            For i = 1 To Ndamp
                k2 = KPdamp(i, 2)
                If k2 > 0 Then
                    k2 = kcbuf(k2)
                    k1 = kcbuf(KPdamp(i, 1))
                    k = Math.Abs(k1 - k2)
                    If k > mx Then
                        mx = k
                    End If
                End If
            Next i
        End If

        mb = Ndim * (mx + 1)

    End Sub

    Private Sub BandWidth3(ByRef mb As Integer, ByVal kcbuf() As Integer, _
        ByVal nvarb() As Integer)
        'ﾊﾞﾝﾄﾞ幅の計算2
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'kcbuf()･･･元の節点の変数順序
        'nvarb()･･･各節点順の変数の数
        Dim i, ie, j, k, j1, j2, jb, jj, k1, k2, mx As Integer

        mx = 0
        For ie = 1 To Nelem
            i = NNelem(ie, 1)
            j = NNelem(ie, 2)
            j1 = kcbuf(i)
            j2 = kcbuf(j)
            If j1 > j2 Then
                jb = j1
                j1 = j2
                j2 = jb
            End If
            k = 0
            For jj = j1 To j2
                k = k + nvarb(jj)
            Next jj
            If k > mx Then
                mx = k
            End If
        Next ie
        If Nspring > 0 Then
            For j = 1 To Nspring
                k1 = KPspring(j, 1)
                k2 = KPspring(j, 2)
                If k2 > 0 Then
                    j1 = kcbuf(k1)
                    j2 = kcbuf(k2)
                    If j1 > j2 Then
                        jb = j1
                        j1 = j2
                        j2 = jb
                    End If
                    k = 0
                    For jj = j1 To j2
                        k = k + nvarb(jj)
                    Next jj
                    If k > mx Then
                        mx = k
                    End If
                End If
            Next j
        End If
        If Ndamp > 0 Then
            For i = 1 To Ndamp
                j2 = KPdamp(i, 2)
                If j2 > 0 Then
                    j2 = kcbuf(j2)
                    j1 = kcbuf(KPdamp(i, 1))
                    If j1 > j2 Then
                        jb = j1
                        j1 = j2
                        j2 = jb
                    End If
                    k = 0
                    For jj = j1 To j2
                        k = k + nvarb(jj)
                    Next jj
                    If k > mx Then
                        mx = k
                    End If
                End If
            Next i
        End If

        mb = mx

    End Sub

    Private Sub CmatSet()
        'Ｃ行列設定
        Dim i, ii, j As Integer
        ReDim Cmatb(NumEff)

        If KindDamp = 0 Then
            For i = 1 To NumEff
                Cmatb(i) = CoeffM * RMmatb(i) + CoeffK * RKmatb(i)
            Next i
        Else
            ii = 0
            For i = 1 To Nall
                If Nodemb(i) > 0 Then
                    ii = ii + 1
                    j = Lcomp(i)
                    Cmatb(Idiag(j)) = Cmatrix(ii)
                End If
            Next i
        End If

        If Ndamp > 0 Then
            Call DampSet()      'ﾀﾞﾝﾊﾟｰの設定
        End If

    End Sub

    Private Sub CoeffMatrix(ByVal istage As Integer, ByVal c1 As Single, _
        ByVal c2 As Single, ByVal c3 As Single, ByVal c4 As Single, _
        ByVal cmass As Single, ByVal rlen As Single)
        '各要素の係数ﾏﾄﾘｯｸｽの計算
        'istage･･･応力計算の有無（0:なし、1:有り）
        'c1,c2,c3,c4･･･部材座標系ﾏﾄﾘｯｸｽの各要素値
        'cmass･･･要素質量
        'rlen･･･要素長さ
        Dim i, j, k As Integer
        Dim b1, b2, b3, b4, b5, b6, b7, b8, s, sm As Single

        b1 = cmass / 3
        b2 = cmass / 6
        Select Case Ntype
            Case 1
                For i = 1 To 4
                    Em(i, i) = b1
                Next i
                Em(1, 3) = b2 : Em(2, 4) = b2
                Em(3, 1) = b2 : Em(4, 2) = b2
                Ek(1, 1) = c1 : Ek(1, 3) = -c1
                Ek(3, 1) = -c1 : Ek(3, 3) = c1
            Case 2
                b3 = cmass * 13 / 35
                b4 = cmass * 9 / 70
                b5 = cmass * rlen * rlen / 105
                b6 = cmass * rlen * rlen / 140
                b7 = cmass * rlen * 11 / 210
                b8 = cmass * rlen * 13 / 420
                Em(1, 1) = b1 : Em(1, 4) = b2
                Em(2, 2) = b3 : Em(2, 3) = b7
                Em(2, 5) = b4 : Em(2, 6) = -b8
                Em(3, 2) = b7 : Em(3, 3) = b5
                Em(3, 5) = b8 : Em(3, 6) = -b6
                Em(4, 1) = b2 : Em(4, 4) = b1
                Em(5, 2) = b4 : Em(5, 3) = b8
                Em(5, 5) = b3 : Em(5, 6) = -b7
                Em(6, 2) = -b8 : Em(6, 3) = -b6
                Em(6, 5) = -b7 : Em(6, 6) = b5
                Ek(1, 1) = c1 : Ek(1, 4) = -c1
                Ek(2, 2) = c2 : Ek(2, 3) = c3
                Ek(2, 5) = -c2 : Ek(2, 6) = c3
                Ek(3, 2) = c3 : Ek(3, 3) = 2 * c4
                Ek(3, 5) = -c3 : Ek(3, 6) = c4
                Ek(4, 1) = -c1 : Ek(4, 4) = c1
                Ek(5, 2) = -c2 : Ek(5, 3) = -c3
                Ek(5, 5) = c2 : Ek(5, 6) = -c3
                Ek(6, 2) = c3 : Ek(6, 3) = c4
                Ek(6, 5) = -c3 : Ek(6, 6) = 2 * c4
        End Select

        If Ntype = 2 Then
            For i = 1 To Nvar
                For j = 1 To Nvar
                    sm = 0
                    For k = 1 To Nvar
                        sm = sm + Em(i, k) * Trans(k, j)
                    Next k
                    Emb(i, j) = sm
                Next j
            Next i
            For i = 1 To Nvar
                For j = 1 To Nvar
                    sm = 0
                    For k = 1 To Nvar
                        sm = sm + Trans(k, i) * Emb(k, j)
                    Next k
                    Em(i, j) = sm
                Next j
            Next i
        End If

        For i = 1 To Nvar
            For j = 1 To Nvar
                s = 0
                For k = 1 To Nvar
                    s = s + Ek(i, k) * Trans(k, j)
                Next k
                Ekb(i, j) = s
            Next j
        Next i

        If istage = 0 Then
            For i = 1 To Nvar
                For j = 1 To Nvar
                    s = 0
                    For k = 1 To Nvar
                        s = s + Trans(k, i) * Ekb(k, j)
                    Next k
                    Ek(i, j) = s
                Next j
            Next i
        End If

    End Sub

    Private Sub CoeffMatrix2(ByVal istage As Integer, ByVal c1 As Single, _
    ByVal c2 As Single, ByVal c3 As Single, ByVal c4 As Single, _
    ByVal rlen As Single)
        '各要素の係数ﾏﾄﾘｯｸｽの計算2（応力計算用）
        'istage･･･応力計算の有無（0:なし、1:有り）
        'c1,c2,c3,c4･･･部材座標系ﾏﾄﾘｯｸｽの各要素値
        'rlen･･･要素長さ
        Dim i, j, k As Integer
        Dim s As Single

        Select Case Ntype
            Case 1
                Ek(1, 1) = c1 : Ek(1, 3) = -c1
                Ek(3, 1) = -c1 : Ek(3, 3) = c1
            Case 2
                Ek(1, 1) = c1 : Ek(1, 4) = -c1
                Ek(2, 2) = c2 : Ek(2, 3) = c3
                Ek(2, 5) = -c2 : Ek(2, 6) = c3
                Ek(3, 2) = c3 : Ek(3, 3) = 2 * c4
                Ek(3, 5) = -c3 : Ek(3, 6) = c4
                Ek(4, 1) = -c1 : Ek(4, 4) = c1
                Ek(5, 2) = -c2 : Ek(5, 3) = -c3
                Ek(5, 5) = c2 : Ek(5, 6) = -c3
                Ek(6, 2) = c3 : Ek(6, 3) = c4
                Ek(6, 5) = -c3 : Ek(6, 6) = 2 * c4
        End Select

        For i = 1 To Nvar
            For j = 1 To Nvar
                s = 0
                For k = 1 To Nvar
                    s = s + Ek(i, k) * Trans(k, j)
                Next k
                Ekb(i, j) = s
            Next j
        Next i
        If istage = 0 Then
            For i = 1 To Nvar
                For j = 1 To Nvar
                    s = 0
                    For k = 1 To Nvar
                        s = s + Trans(k, i) * Ekb(k, j)
                    Next k
                    Ek(i, j) = s
                Next j
            Next i
        End If

    End Sub

    Private Sub CoeffMatrix2SK(ByVal istage As Integer, ByVal kc As Integer, _
    ByVal c1 As Single, ByVal c2 As Single, ByVal c3 As Single, _
    ByVal c4 As Single, ByVal rlen As Single)
        '各要素の係数ﾏﾄﾘｯｸｽの計算2（応力計算用）
        'istage･･･応力計算の有無（0:なし、1:有り）
        'kc･･･要素種類（1:ﾄﾗｽ、2:ﾗｰﾒﾝ、3:左端回転自由、4:右端回転自由）
        'c1,c2,c3,c4･･･部材座標系ﾏﾄﾘｯｸｽの各要素値
        'rlen･･･要素長さ
        Dim i, j, k As Integer
        Dim cb, c5, c6, s As Single

        cb = 1.0 - Crate
        Ek(1, 1) = c1 : Ek(1, 4) = -c1
        Ek(4, 1) = -c1 : Ek(4, 4) = c1
        c5 = 0.25 * c2
        c6 = 0.5 * c3
        Select Case kc
            Case 2
                Ek(2, 2) = c2 : Ek(2, 3) = c3
                Ek(2, 5) = -c2 : Ek(2, 6) = c3
                Ek(3, 2) = c3 : Ek(3, 3) = 2 * c4
                Ek(3, 5) = -c3 : Ek(3, 6) = c4
                Ek(5, 2) = -c2 : Ek(5, 3) = -c3
                Ek(5, 5) = c2 : Ek(5, 6) = -c3
                Ek(6, 2) = c3 : Ek(6, 3) = c4
                Ek(6, 5) = -c3 : Ek(6, 6) = 2 * c4
            Case 3
                Ek(2, 2) = c5
                Ek(2, 5) = -c5 : Ek(2, 6) = c6
                Ek(5, 2) = -c5
                Ek(5, 5) = c5 : Ek(5, 6) = -c6
                Ek(6, 2) = c6
                Ek(6, 5) = -c6 : Ek(6, 6) = 1.5 * c4
            Case 4
                Ek(2, 2) = c5 : Ek(2, 3) = c6
                Ek(2, 5) = -c5
                Ek(3, 2) = c6 : Ek(3, 3) = 1.5 * c4
                Ek(3, 5) = -c6
                Ek(5, 2) = -c5 : Ek(5, 3) = -c6
                Ek(5, 5) = c5
        End Select
        If kc > 2 Then
            Ek(2, 2) = cb * Ek(2, 2) + Crate * c2
            Ek(2, 3) = cb * Ek(2, 3) + Crate * c3
            Ek(3, 2) = Ek(2, 3)
            Ek(2, 5) = cb * Ek(2, 5) - Crate * c2
            Ek(5, 2) = Ek(2, 5)
            Ek(2, 6) = cb * Ek(2, 6) + Crate * c3
            Ek(6, 2) = Ek(2, 6)
            Ek(3, 3) = cb * Ek(3, 3) + Crate * 2 * c4
            Ek(3, 5) = cb * Ek(3, 5) - Crate * c3
            Ek(5, 3) = Ek(3, 5)
            Ek(3, 6) = cb * Ek(3, 6) + Crate * c4
            Ek(6, 3) = Ek(3, 6)
            Ek(5, 5) = cb * Ek(5, 5) + Crate * c2
            Ek(5, 6) = cb * Ek(5, 6) - Crate * c3
            Ek(6, 5) = Ek(5, 6)
            Ek(6, 6) = cb * Ek(6, 6) + Crate * 2 * c4
        End If

        For i = 1 To Nvar
            For j = 1 To Nvar
                s = 0
                For k = 1 To Nvar
                    s = s + Ek(i, k) * Trans(k, j)
                Next k
                Ekb(i, j) = s
            Next j
        Next i
        If istage = 0 Then
            For i = 1 To Nvar
                For j = 1 To Nvar
                    s = 0
                    For k = 1 To Nvar
                        s = s + Trans(k, i) * Ekb(k, j)
                    Next k
                    Ek(i, j) = s
                Next j
            Next i
        End If

    End Sub

    Private Sub CoeffMatrixSK(ByVal istage As Integer, ByVal kc As Integer, _
    ByVal c1 As Single, ByVal c2 As Single, ByVal c3 As Single, _
    ByVal c4 As Single, ByVal cmass As Single, ByVal rlen As Single)
        '各要素の係数ﾏﾄﾘｯｸｽの計算
        'istage･･･応力計算の有無（0:なし、1:有り）
        'kc･･･要素種類（1:ﾄﾗｽ、2:ﾗｰﾒﾝ、3:左端回転自由、4:右端回転自由）
        'c1,c2,c3,c4･･･部材座標系ﾏﾄﾘｯｸｽの各要素値
        'cmass･･･要素質量
        'rlen･･･要素長さ
        Dim i, j, k As Integer
        Dim b1, b2, b3, b4, b5, b6, b7, b8, c5, c6, cb, s, sm As Single

        cb = 1.0 - Crate
        b1 = cmass / 3
        b2 = cmass / 6
        Em(1, 1) = b1 : Em(1, 4) = b2
        Em(4, 1) = b2 : Em(4, 4) = b1
        c5 = 0.25 * c2
        c6 = 0.5 * c3
        Ek(1, 1) = c1 : Ek(1, 4) = -c1
        Ek(4, 1) = -c1 : Ek(4, 4) = c1
        Select Case kc
            Case 1
                Em(2, 2) = b1 : Em(2, 5) = b2
                Em(5, 2) = b2 : Em(5, 5) = b1
            Case 2
                b3 = cmass * 13 / 35
                b4 = cmass * 9 / 70
                b5 = cmass * rlen * rlen / 105
                b6 = cmass * rlen * rlen / 140
                b7 = cmass * rlen * 11 / 210
                b8 = cmass * rlen * 13 / 420
                Em(2, 2) = b3 : Em(2, 3) = b7
                Em(2, 5) = b4 : Em(2, 6) = -b8
                Em(3, 2) = b7 : Em(3, 3) = b5
                Em(3, 5) = b8 : Em(3, 6) = -b6
                Em(5, 2) = b4 : Em(5, 3) = b8
                Em(5, 5) = b3 : Em(5, 6) = -b7
                Em(6, 2) = -b8 : Em(6, 3) = -b6
                Em(6, 5) = -b7 : Em(6, 6) = b5
                Ek(2, 2) = c2 : Ek(2, 3) = c3
                Ek(2, 5) = -c2 : Ek(2, 6) = c3
                Ek(3, 2) = c3 : Ek(3, 3) = 2 * c4
                Ek(3, 5) = -c3 : Ek(3, 6) = c4
                Ek(5, 2) = -c2 : Ek(5, 3) = -c3
                Ek(5, 5) = c2 : Ek(5, 6) = -c3
                Ek(6, 2) = c3 : Ek(6, 3) = c4
                Ek(6, 5) = -c3 : Ek(6, 6) = 2 * c4
            Case 3
                Em(2, 2) = cmass / 5
                Em(2, 5) = 2 * cmass / 15
                Em(2, 6) = -cmass * rlen / 20
                Em(5, 5) = 8 * cmass / 15
                Em(5, 6) = -7 * cmass * rlen / 60
                Em(6, 6) = cmass * rlen * rlen / 30
                Em(5, 2) = Em(2, 5)
                Em(6, 2) = Em(2, 6) : Em(6, 5) = Em(5, 6)
                Ek(2, 2) = c5
                Ek(2, 5) = -c5 : Ek(2, 6) = c6
                Ek(5, 2) = -c5
                Ek(5, 5) = c5 : Ek(5, 6) = -c6
                Ek(6, 2) = c6
                Ek(6, 5) = -c6 : Ek(6, 6) = 1.5 * c4
            Case 4
                Em(2, 2) = 8 * cmass / 15
                Em(2, 3) = 7 * cmass * rlen / 60
                Em(2, 5) = 2 * cmass / 15
                Em(3, 3) = cmass * rlen * rlen / 30
                Em(3, 5) = cmass * rlen / 20
                Em(5, 5) = cmass / 5
                Em(3, 2) = Em(2, 3)
                Em(5, 2) = Em(2, 5) : Em(5, 3) = Em(3, 5)
                Ek(2, 2) = c5 : Ek(2, 3) = c6
                Ek(2, 5) = -c5
                Ek(3, 2) = c6 : Ek(3, 3) = 1.5 * c4
                Ek(3, 5) = -c6
                Ek(5, 2) = -c5 : Ek(5, 3) = -c6
                Ek(5, 5) = c5
        End Select
        If kc > 2 Then
            b3 = cmass * 13 / 35
            b4 = cmass * 9 / 70
            b5 = cmass * rlen * rlen / 105
            b6 = cmass * rlen * rlen / 140
            b7 = cmass * rlen * 11 / 210
            b8 = cmass * rlen * 13 / 420
            Em(2, 2) = cb * Em(2, 2) + Crate * b3
            Em(2, 3) = cb * Em(2, 3) + Crate * b7
            Em(3, 2) = Em(2, 3)
            Em(2, 5) = cb * Em(2, 5) + Crate * b4
            Em(5, 2) = Em(2, 5)
            Em(2, 6) = cb * Em(2, 6) - Crate * b8
            Em(6, 2) = Em(2, 6)
            Em(3, 3) = cb * Em(3, 3) + Crate * b5
            Em(3, 5) = cb * Em(3, 5) + Crate * b8
            Em(5, 3) = Em(3, 5)
            Em(3, 6) = cb * Em(3, 6) - Crate * b6
            Em(6, 3) = Em(3, 6)
            Em(5, 5) = cb * Em(5, 5) + Crate * b3
            Em(5, 6) = cb * Em(5, 6) - Crate * b7
            Em(6, 5) = Em(5, 6)
            Em(6, 6) = cb * Em(6, 6) + Crate * b5

            Ek(2, 2) = cb * Ek(2, 2) + Crate * c2
            Ek(2, 3) = cb * Ek(2, 3) + Crate * c3
            Ek(3, 2) = Ek(2, 3)
            Ek(2, 5) = cb * Ek(2, 5) - Crate * c2
            Ek(5, 2) = Ek(2, 5)
            Ek(2, 6) = cb * Ek(2, 6) + Crate * c3
            Ek(6, 2) = Ek(2, 6)
            Ek(3, 3) = cb * Ek(3, 3) + Crate * 2 * c4
            Ek(3, 5) = cb * Ek(3, 5) - Crate * c3
            Ek(5, 3) = Ek(3, 5)
            Ek(3, 6) = cb * Ek(3, 6) + Crate * c4
            Ek(6, 3) = Ek(3, 6)
            Ek(5, 5) = cb * Ek(5, 5) + Crate * c2
            Ek(5, 6) = cb * Ek(5, 6) - Crate * c3
            Ek(6, 5) = Ek(5, 6)
            Ek(6, 6) = cb * Ek(6, 6) + Crate * 2 * c4
        End If

        If kc > 1 Then
            For i = 1 To Nvar
                For j = 1 To Nvar
                    sm = 0
                    For k = 1 To Nvar
                        sm = sm + Em(i, k) * Trans(k, j)
                    Next k
                    Emb(i, j) = sm
                Next j
            Next i
            For i = 1 To Nvar
                For j = 1 To Nvar
                    sm = 0
                    For k = 1 To Nvar
                        sm = sm + Trans(k, i) * Emb(k, j)
                    Next k
                    Em(i, j) = sm
                Next j
            Next i
        End If

        For i = 1 To Nvar
            For j = 1 To Nvar
                s = 0
                For k = 1 To Nvar
                    s = s + Ek(i, k) * Trans(k, j)
                Next k
                Ekb(i, j) = s
            Next j
        Next i

        If istage = 0 Then
            For i = 1 To Nvar
                For j = 1 To Nvar
                    s = 0
                    For k = 1 To Nvar
                        s = s + Trans(k, i) * Ekb(k, j)
                    Next k
                    Ek(i, j) = s
                Next j
            Next i
        End If

    End Sub

    Private Sub ConvResultU(ByVal iconv As Integer, ByVal ik As Integer)
        '収束結果の出力
        'UTF-8･･･BOMなし
        'iconv･･･収束経緯（0:初、1:済み）
        'ik･･･繰返し計算回数
        Dim aa$, ad$
        Dim b1 As Single

        ad$ = "-------------------------------------------------------"
        SwK.WriteLine(ad$)
        If iconv = 0 Then
            aa$ = "収束繰返し回数" + "," + Str(ik)
        Else
            aa$ = "繰返し回数" + "," + Str(ik)
        End If
        SwK.WriteLine(aa$)
        b1 = Math.Abs(DeltaMax - DeltaMaxb)
        aa$ = "旧変位、新変位、差" + "," + Str(DeltaMaxb)
        aa$ = aa$ + "," + Str(DeltaMax) + "," + Str(b1)
        SwK.WriteLine(aa$)

    End Sub

    Private Sub CosCalc2(ByVal aval1() As Single, ByVal aval2() As Single, _
        ByRef acos() As Single)
        '2点間の方向余弦の計算
        'aval1(),aval2()・・・2点のXY座標
        'acos()・・・XY座標への方向余弦
        Dim j As Integer
        Dim b1 As Single
        Dim buf(2) As Single

        For j = 1 To 2
            buf(j) = aval2(j) - aval1(j)
        Next j
        b1 = 0
        For j = 1 To 2
            b1 = b1 + buf(j) * buf(j)
        Next j
        b1 = Math.Sqrt(b1)
        For j = 1 To 2
            acos(j) = buf(j) / b1
        Next j

    End Sub

    Private Sub DampSet()
        'ﾀﾞﾝﾊﾟｰの設定
        Dim i, j, k, k1, k2, kb, kk, kx As Integer
        Dim b1, b2, cb As Single
        Dim k1buf(2), k2buf(2) As Single
        Dim acos(2), aval1(2), aval2(2) As Single

        For i = 1 To Ndamp
            k1 = KPdamp(i, 1)
            aval1(1) = X(k1)
            aval1(2) = Y(k1)
            k2 = KPdamp(i, 2)
            If k2 > 0 Then
                aval2(1) = X(k2)
                aval2(2) = Y(k2)
            Else
                aval2(1) = DataDamp(i, 1)
                aval2(2) = DataDamp(i, 2)
            End If
            Call CosCalc2(aval1, aval2, acos) '2点間の方向余弦の計算
            cb = DataDamp(i, 3)
            If Ntype < 3 Then
                kb = Ndim * (k1 - 1)
            Else
                kb = LrD(k1) - 1
            End If
            For j = 1 To 2
                k1buf(j) = Lcomp(kb + j)
            Next j
            For k = 1 To 2
                kk = k1buf(k)
                If kk > 0 Then
                    b1 = acos(k) * cb
                    For j = k To 2
                        kb = k1buf(j)
                        If kb > 0 Then
                            kx = Idiag(kb) - kb + kk
                            Cmatb(kx) = Cmatb(kx) + b1 * acos(j)
                        End If
                    Next j
                End If
            Next k
            If k2 > 0 Then
                If Ntype < 3 Then
                    kb = Ndim * (k2 - 1)
                Else
                    kb = LrD(k2) - 1
                End If
                For j = 1 To 2
                    k2buf(j) = Lcomp(kb + j)
                Next j
                For k = 1 To 2
                    kk = k2buf(k)
                    If kk > 0 Then
                        b1 = acos(k) * cb
                        For j = k To 2
                            kb = k2buf(j)
                            If kb > 0 Then
                                kx = Idiag(kb) - kb + kk
                                Cmatb(kx) = Cmatb(kx) + b1 * acos(j)
                            End If
                        Next j
                        For j = k To 2
                            kb = k1buf(j)
                            If kb > 0 Then
                                b2 = b1 * acos(j)
                                If kb > kk Then
                                    kx = Idiag(kb) - kb + kk
                                Else
                                    kx = Idiag(kk) - kk + kb
                                End If
                                Cmatb(kx) = Cmatb(kx) - b2
                            End If
                        Next j
                    End If
                Next k
            End If
        Next i

    End Sub

    Private Sub Debug3()
        '変位、速度、加速度を出力して停止
        Dim aa$, fxx$
        Dim i, id, ii, kb, k As Integer

        ii = FreeFile()
        fxx$ = DirOpen$ + "\BarsVRCal3debug3.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "＜＜動的な変位、速度、加速度のデータ＞＞"
        WriteLine(ii, aa$)
        aa$ = "時間、節点番号、各変位、各速度、各加速度"
        WriteLine(ii, aa$)
        For i = 1 To Npoint
            aa$ = Str$(TimeNew) + ",  " + Str$(i)
            kb = Ndim * (i - 1)
            For id = 1 To Ndim
                k = kb + id
                aa$ = aa$ + ",  " + Str$(Disp2(Lcomp(k)))
            Next id
            For id = 1 To Ndim
                k = kb + id
                aa$ = aa$ + ",  " + Str$(Vel2(Lcomp(k)))
            Next id
            For id = 1 To Ndim
                k = kb + id
                aa$ = aa$ + ",  " + Str$(Accel2(Lcomp(k)))
            Next id
            PrintLine(ii, aa$)
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub Debug4()
        'Nodemb()とLcomp()を出力して停止
        Dim aa$, fxx$
        Dim i, ii As Integer

        ii = FreeFile()
        fxx$ = DirOpen$ + "\BarsVRCal3debug3.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "＜＜Nodemb()とLcomp()のデータ＞＞"
        WriteLine(ii, aa$)
        aa$ = "元行列の変数番号、Nodemb()、Lcomp()"
        WriteLine(ii, aa$)
        For i = 1 To Nall
            aa$ = Str$(i) + ",  " + Str$(Nodemb(i)) + ",  " + Str$(Lcomp(i))
            PrintLine(ii, aa$)
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub Debug5()
        '右辺ﾍﾞｸﾄﾙを出力して停止
        Dim aa$, fxx$
        Dim i, ii As Integer

        ii = FreeFile()
        fxx$ = DirOpen$ + "\BarsVRCal3debug3.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "＜＜右辺ベクトルのデータ＞＞"
        WriteLine(ii, aa$)
        aa$ = "元行列の変数番号、TfD()"
        WriteLine(ii, aa$)
        For i = 1 To Nall
            aa$ = Str$(i) + ",  " + Str$(TfD(i))
            PrintLine(ii, aa$)
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub Debug7()
        '要素ﾏﾄﾘｯｸｽを出力して停止
        Dim aa$, fxx$
        Dim i, ii, j As Integer
        ii = FreeFile()
        fxx$ = DirOpen$ + "\BarsVRCal3debug3.dat"
        FileOpen(ii, fxx$, OpenMode.Output)
        aa$ = "要素マトリックス"
        WriteLine(ii, aa$)
        WriteLine(ii, "行番号、各行列要素")
        For i = 1 To Nvar
            aa$ = Str$(i)
            For j = 1 To Nvar
                aa$ = aa$ + ",  " + Str$(Ek(i, j))
            Next j
            PrintLine(ii, aa$)
        Next i
        FileClose(ii)
        Stop
    End Sub

    Private Sub DispCalc()
        '変位の計算
        Dim i As Integer
        Dim b1, c1, c2 As Double

        c1 = 0.5 * DTime
        For i = 1 To Norder
            If KDispSet(i) = 0 Then
                Vel2(i) = Vel1(i) + c1 * (Accel1(i) + Accel2(i))
            End If
        Next i
        c1 = (0.5 - Beta) * DTime * DTime
        c2 = Beta * DTime * DTime
        For i = 1 To Norder
            If KDispSet(i) = 0 Then
                b1 = Disp1(i) + DTime * Vel1(i)
                Disp2(i) = b1 + c1 * Accel1(i) + c2 * Accel2(i)
            End If
        Next i

    End Sub

    Private Sub DispCheck()
        '変位のﾁｪｯｸ
        Dim i As Integer
        Dim b1, b2 As Single

        b1 = 0
        For i = 1 To Norder
            If KcheckP(i) = 0 Then
                b2 = Math.Abs(Disp2(i))
                If b2 > b1 Then
                    b1 = b2
                End If
            End If
        Next i
        If b1 > DeltaMax Then
            DeltaMax = b1
        End If

    End Sub

    Private Sub ElemMatrix(ByVal ie As Integer, ByVal istage As Integer, _
    ByRef kb As Integer, ByRef e As Single, ByRef rou As Single, _
    ByRef area As Single, ByRef ri As Single)
        '要素ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'istage･･･応力計算の有無（0:なし、1:有り）
        'kb･･･材料番号
        'e･･･ﾔﾝｸﾞ率
        'rou･･･材料の密度
        'area･･･断面積
        'ri･･･断面2次ﾓｰﾒﾝﾄ
        Dim i, id, ii, j, k, kc, kp, nb As Integer
        Dim b1, b2, b3, c1, c2, c3, c4, rlen, cc, cmass, cs As Single

        kp = NumMat(ie)
        If kp <> kb Then
            kb = kp
            e = DataMat(kp, 1)
            rou = RouMat(kp)
            area = DataMat(kp, 3)
            If Ntype > 1 Then
                ri = DataMat(kp, 4)
            End If
        End If

        kc = 0      '要素節点支持分類
        j = 0
        For ii = 1 To 2
            i = NNelem(ie, ii)
            XE(ii) = X(i)
            YE(ii) = Y(i)
            If Ntype < 3 Then
                'k = Ndim * (i - 1)
                k = Ndim * (Kcomp(i) - 1)
                For id = 1 To Ndim
                    j = j + 1
                    k = k + 1
                    NPrefer(j) = k
                    If istage > 0 Then
                        Efb(j) = TfD(k)
                    End If
                Next id
            Else
                k = Lr(i) - 1
                nb = NvarP(Kcomp(i))
                For id = 1 To 3
                    j = j + 1
                    k = k + 1
                    If id > nb Then
                        NPrefer(j) = 0
                    Else
                        NPrefer(j) = k
                    End If
                    If istage > 0 Then
                        If id > nb Then
                            Efb(j) = 0
                        Else
                            Efb(j) = TfD(k)
                        End If
                    End If
                Next id
            End If
        Next ii

        b1 = XE(2) - XE(1)
        b2 = YE(2) - YE(1)
        rlen = Math.Sqrt(b1 * b1 + b2 * b2)
        cs = b2 / rlen
        cc = b1 / rlen
        c1 = e * area / rlen
        If Ntype > 1 Then
            b3 = e * ri / rlen
            c2 = 12 * b3 / (rlen * rlen)
            c3 = 6 * b3 / rlen
            c4 = 2 * b3
        End If
        cmass = rou * area * rlen

        For i = 1 To Nvar
            For j = 1 To Nvar
                Ek(i, j) = 0
                Em(i, j) = 0
                Trans(i, j) = 0
            Next j
        Next i

        Call TransMatrix(cs, cc)   '座標変換行列の設定

        If Ntype < 3 Then
            Call CoeffMatrix(istage, c1, c2, c3, c4, cmass, rlen)   '各要素の係数ﾏﾄﾘｯｸｽの計算
        Else
            kc = KindElem(ie)
            Call CoeffMatrixSK(istage, kc, c1, c2, c3, c4, cmass, rlen) '各要素の係数ﾏﾄﾘｯｸｽの計算
        End If

    End Sub

    Private Sub ElemMatrix2(ByVal ie As Integer, ByVal istage As Integer, _
    ByRef kb As Integer, ByRef e As Single, ByRef area As Single, _
    ByRef ri As Single)
        '要素ﾏﾄﾘｯｸｽの計算2
        'ie･･･要素番号
        'istage･･･応力計算の有無（0:なし、1:有り）
        'kb･･･材料番号
        'e･･･ﾔﾝｸﾞ率
        'area･･･断面積
        'ri･･･断面2次ﾓｰﾒﾝﾄ
        Dim i, id, ii, j, k, kc, kp, nb As Integer
        Dim b1, b2, b3, c1, c2, c3, c4, rlen, cc, cs As Single

        kp = NumMat(ie)
        If kp <> kb Then
            kb = kp
            e = DataMat(kp, 1)
            area = DataMat(kp, 3)
            If Ntype > 1 Then
                ri = DataMat(kp, 4)
            End If
        End If

        kc = 0      '要素節点支持分類
        j = 0
        For ii = 1 To 2
            i = NNelem(ie, ii)
            XE(ii) = X(i)
            YE(ii) = Y(i)
            If Ntype < 3 Then
                'k = Ndim * (i - 1)
                k = Ndim * (Kcomp(i) - 1)
                For id = 1 To Ndim
                    j = j + 1
                    k = k + 1
                    NPrefer(j) = k
                    If istage > 0 Then
                        Efb(j) = TfD(k)
                    End If
                Next id
            Else
                k = Lr(i) - 1
                nb = NvarP(Kcomp(i))
                For id = 1 To 3
                    j = j + 1
                    k = k + 1
                    NPrefer(j) = k
                    If id > nb Then
                        NPrefer(j) = 0
                    Else
                        NPrefer(j) = k
                    End If
                    If istage > 0 Then
                        If id > nb Then
                            Efb(j) = 0
                        Else
                            Efb(j) = TfD(k)
                        End If
                    End If
                Next id
            End If
        Next ii

        b1 = XE(2) - XE(1)
        b2 = YE(2) - YE(1)
        rlen = Math.Sqrt(b1 * b1 + b2 * b2)
        cs = b2 / rlen
        cc = b1 / rlen
        c1 = e * area / rlen
        If Ntype > 1 Then
            b3 = e * ri / rlen
            c2 = 12 * b3 / (rlen * rlen)
            c3 = 6 * b3 / rlen
            c4 = 2 * b3
        End If

        For i = 1 To Nvar
            For j = 1 To Nvar
                Ek(i, j) = 0
                Trans(i, j) = 0
            Next j
        Next i

        Call TransMatrix(cs, cc)   '座標変換行列の設定
        If Ntype < 3 Then
            Call CoeffMatrix2(istage, c1, c2, c3, c4, rlen) '各要素の係数ﾏﾄﾘｯｸｽの計算2
        Else
            kc = KindElem(ie)
            Call CoeffMatrix2SK(istage, kc, c1, c2, c3, c4, rlen)    '各要素の係数ﾏﾄﾘｯｸｽの計算
        End If

    End Sub

    Private Sub FLoadSet()
        '節点荷重の設定
        Dim i, id, j As Integer
        For i = 1 To Nforce
            'j = Ndim * (KPforce(i) - 1)
            j = Ndim * (Kcomp(KPforce(i)) - 1)
            For id = 1 To Ndim
                j = j + 1
                TfD(j) = Force(i, id)
            Next id
        Next i

    End Sub

    Private Sub FLoadSet2()
        '節点荷重の設定2
        Dim i, id, j As Integer
        For i = 1 To Nforce
            j = Lr(KPforce(i)) - 1
            For id = 1 To NvarP(Kcomp(KPforce(i)))
                j = j + 1
                TfD(j) = Force(i, id)
            Next id
        Next i

    End Sub

    Private Sub FMaxMin(ByRef ic As Integer, ByVal ie As Integer, _
        ByVal ii As Integer, ByVal jj As Integer, ByVal c1 As Single, _
        ByVal zbuf() As Single)
        '軸力等の最大・最小のﾁｪｯｸ
        'ic･･･初期設定の有無（0:なし、1:有り、2:一部有り）
        'ie･･･要素番号
        'ii･･･節点番号
        'jj･･･軸力等配列のﾍﾞｰｽ値(0またはNdim)
        'c1･･･時間または角度
        'zbuf()･･･各応力
        Dim icc, k As Integer
        Dim zb As Single

        icc = 0 '曲げの有無
        Select Case Ntype
            Case 2
                icc = 1
            Case 3
                If KindElem(ie) = 2 Then
                    icc = 1
                Else
                    If jj = 0 Then
                        If KindElem(ie) = 4 Then
                            icc = 1
                        End If
                    Else
                        If KindElem(ie) = 3 Then
                            icc = 1
                        End If
                    End If
                End If
        End Select
        If ic = 0 Then
            For k = 0 To 2
                Select Case k
                    Case 0
                        zb = zbuf(0)
                    Case Else
                        zb = EForce(jj + k)
                End Select
                KEfmax(k) = 1
                KEfmin(k) = 1
                KPfmax(k) = ii
                KPfmin(k) = ii
                Zfmax(k) = zb
                Zfmin(k) = zb
                Tfmax(k) = c1
                Tfmin(k) = c1
            Next k
            Select Case Ntype
                Case 1
                    KEfmax(3) = 1
                    KPfmax(3) = ii
                    Zfmax(3) = zbuf(1)
                    Tfmax(3) = c1
                Case Else
                    If icc > 0 Then
                        For k = 3 To 5
                            Select Case k
                                Case 3
                                    zb = EForce(jj + k)
                                Case Else
                                    zb = zbuf(k - 3)
                            End Select
                            KEfmax(k) = 1
                            KEfmin(k) = 1
                            KPfmax(k) = ii
                            KPfmin(k) = ii
                            Zfmax(k) = zb
                            Zfmin(k) = zb
                            Tfmax(k) = c1
                            Tfmin(k) = c1
                        Next k
                    End If
                    For k = 6 To 7
                        zb = zbuf(k - 3)
                        KEfmax(k) = 1
                        KEfmin(k) = 1
                        KPfmax(k) = ii
                        KPfmin(k) = ii
                        Zfmax(k) = zb
                        Zfmin(k) = zb
                        Tfmax(k) = c1
                        Tfmin(k) = c1
                    Next k
                    KEfmax(8) = 1
                    KPfmax(8) = ii
                    Zfmax(8) = zbuf(5)
                    Tfmax(8) = c1
            End Select
            ic = 1
            If Ntype > 1 And icc = 0 Then
                ic = 2
            End If
        Else
            For k = 0 To 2
                Select Case k
                    Case 0
                        zb = zbuf(0)
                    Case Else
                        zb = EForce(jj + k)
                End Select
                If zb < Zfmin(k) Then
                    KEfmin(k) = ie
                    KPfmin(k) = ii
                    Zfmin(k) = zb
                    Tfmin(k) = c1
                ElseIf zb > Zfmax(k) Then
                    KEfmax(k) = ie
                    KPfmax(k) = ii
                    Zfmax(k) = zb
                    Tfmax(k) = c1
                End If
            Next k
            Select Case Ntype
                Case 1
                    zb = zbuf(1)
                    If zb > Zfmax(3) Then
                        KEfmax(3) = ie
                        KPfmax(3) = ii
                        Zfmax(3) = zb
                        Tfmax(3) = c1
                    End If
                Case Else
                    If icc > 0 Then
                        If ic = 1 Then
                            For k = 3 To 5
                                Select Case k
                                    Case 3
                                        zb = EForce(jj + k)
                                    Case Else
                                        zb = zbuf(k - 3)
                                End Select
                                If zb < Zfmin(k) Then
                                    KEfmin(k) = ie
                                    KPfmin(k) = ii
                                    Zfmin(k) = zb
                                    Tfmin(k) = c1
                                ElseIf zb > Zfmax(k) Then
                                    KEfmax(k) = ie
                                    KPfmax(k) = ii
                                    Zfmax(k) = zb
                                    Tfmax(k) = c1
                                End If
                            Next k
                        Else
                            For k = 3 To 5
                                Select Case k
                                    Case 3
                                        zb = EForce(jj + k)
                                    Case Else
                                        zb = zbuf(k - 3)
                                End Select
                                KEfmax(k) = 1
                                KEfmin(k) = 1
                                KPfmax(k) = ii
                                KPfmin(k) = ii
                                Zfmax(k) = zb
                                Zfmin(k) = zb
                                Tfmax(k) = c1
                                Tfmin(k) = c1
                            Next k
                            ic = 2
                        End If
                    End If
                    For k = 6 To 7
                        zb = zbuf(k - 3)
                        If zb < Zfmin(k) Then
                            KEfmin(k) = ie
                            KPfmin(k) = ii
                            Zfmin(k) = zb
                            Tfmin(k) = c1
                        ElseIf zb > Zfmax(k) Then
                            KEfmax(k) = ie
                            KPfmax(k) = ii
                            Zfmax(k) = zb
                            Tfmax(k) = c1
                        End If
                    Next k
                    zb = zbuf(5)
                    If zb > Zfmax(8) Then
                        KEfmax(8) = ie
                        KPfmax(8) = ii
                        Zfmax(8) = zb
                        Tfmax(8) = c1
                    End If
            End Select
        End If

    End Sub

    Private Sub ForceCalc(ByVal istep As Integer)
        '軸力等の計算
        'istep･･･ｽﾃｯﾌﾟ番号
        Dim a1$, aa$
        Dim i, ic, id, ie, ii, istage, j, jb, jj, k, kb, kflag, nb As Integer
        Dim area, b1, b2, b3, c1, e, ri, s As Single
        Dim zbuf(5) As Single

        For i = 1 To Nall
            TfD(i) = 0
        Next i
        If KAnal = 0 Then
            a1$ = "時間、"
            c1 = TimeNew
        Else
            c1 = 360.0 * istep / NdivCyc
            a1$ = "角度、"
        End If
        aa$ = a1$ + "要素No.、節点No.、σf、軸力、剪断力"
        Select Case Ntype
            Case 1
                aa$ = aa$ + "、τ"
            Case Else
                aa$ = aa$ + "、Ｍ、     σ1b、σ2b、σ1A、σ2A、τ"
        End Select
        SwK.WriteLine("----------------------------------------------")
        SwK.WriteLine("＊＊ 応力・軸力等の出力 ＊＊")
        SwK.WriteLine(aa$)

        For i = 1 To Npoint
            If Ntype < 3 Then
                jb = Ndim * (i - 1)
                j = Ndim * (Kcomp(i) - 1)
                nb = Ndim
            Else
                jb = LrD(i) - 1
                j = Lr(i) - 1
                nb = NvarPD(i)
            End If
            For id = 1 To nb
                kb = jb + id
                k = j + id
                TfD(k) = TfS(kb) + Disp2(Lcomp(kb))
            Next id
        Next i

        istage = 1
        If TimeNew = 0 Then
            ic = 0
        Else
            ic = 1
        End If
        kb = 0
        For ie = 1 To Nelem
            Call ElemMatrix2(ie, istage, kb, e, area, ri)   '要素ﾏﾄﾘｯｸｽの計算
            For i = 1 To Nvar
                s = 0
                For j = 1 To Nvar
                    s = s + Ekb(i, j) * Efb(j)
                Next j
                EForce(i) = s
            Next i
            For i = 1 To 2
                ii = NNelem(ie, i)
                jj = Ndim * (i - 1)
                b1 = EForce(jj + 1)
                b2 = EForce(jj + 2)
                If i = 1 Then
                    b1 = -b1
                Else
                    b2 = -b2
                End If
                EForce(jj + 1) = b1 + BarForce(ie, i)
                EForce(jj + 2) = b2 + BarShear(ie, i)
                kflag = 0
                Select Case Ntype
                    Case 2
                        kflag = 1
                    Case 3
                        If i = 1 Then
                            If KindElem(ie) = 2 Or KindElem(ie) = 4 Then
                                kflag = 1
                            End If
                        Else
                            If KindElem(ie) = 2 Or KindElem(ie) = 3 Then
                                kflag = 1
                            End If
                        End If
                End Select
                zbuf(0) = EForce(jj + 1) / area
                If kflag = 0 Then
                    If Ntype = 1 Then
                        zbuf(1) = DataMat(kb, 4) * Math.Abs(EForce(jj + 2)) / area
                    Else
                        zbuf(1) = 0
                        zbuf(2) = 0
                        zbuf(3) = zbuf(0)
                        zbuf(4) = zbuf(0)
                        zbuf(5) = DataMat(kb, 7) * Math.Abs(EForce(jj + 2)) / area
                    End If
                Else
                    b3 = EForce(jj + 3)
                    If i = 1 Then
                        b3 = -b3
                    End If
                    EForce(jj + 3) = b3 + BarMoment(ie, i)
                    b1 = EForce(jj + 3)
                    If i = 1 Then
                        zbuf(1) = -b1 / DataMat(kb, 5)
                        zbuf(2) = b1 / DataMat(kb, 6)
                    Else
                        zbuf(1) = b1 / DataMat(kb, 5)
                        zbuf(2) = -b1 / DataMat(kb, 6)
                    End If
                    zbuf(3) = zbuf(0) + zbuf(1)
                    zbuf(4) = zbuf(0) + zbuf(2)
                    zbuf(5) = DataMat(kb, 7) * Math.Abs(EForce(jj + 2)) / area
                End If
                Call ForceOut(ie, ii, jj, c1, zbuf) '軸力等の出力
                Call FMaxMin(ic, ie, ii, jj, c1, zbuf) '軸力等の最大・最小のﾁｪｯｸ
            Next i
        Next ie

    End Sub

    Private Sub ForceCalc2(ByVal istep As Integer, ByVal mb As Integer)
        '全節点の力等計算
        'istep･･･ｽﾃｯﾌﾟ番号
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        Dim a1$, aa$
        Dim i, ib, id, ie, ip, istage, j, jb, jj, k, kb, kk, mx, nb As Integer
        Dim area, b1, c1, e, ri, s As Single
        Dim buf(Nall) As Single

        If KAnal = 0 Then
            a1$ = "時間、"
            c1 = TimeNew
        Else
            c1 = 360.0 * istep / NdivCyc
            a1$ = "角度、"
        End If

        For i = 1 To NumEff0
            Tk(i) = 0
        Next i

        istage = 0
        kb = 0
        For ie = 1 To Nelem
            Call ElemMatrix2(ie, istage, kb, e, area, ri)   '要素ﾏﾄﾘｯｸｽの計算2
            Call Store()                                    '全体ﾏﾄﾘｯｸｽへの蓄積
        Next ie

        For k = 1 To Nall
            s = 0
            mx = mb
            If k + mb - 1 > Nall Then
                mx = Nall - k + 1
            End If
            For j = 1 To mx
                jj = k + j - 1
                jb = Idiag0(jj) - jj
                kk = jb + k
                If kk > Idiag0(jj - 1) Then
                    s = s + Tk(kk) * TfD(jj)
                End If
            Next j
            mx = k - 1
            If mx > mb - 1 Then
                mx = mb - 1
            End If
            If mx > 0 Then
                jb = Idiag0(k) - k
                For j = 1 To mx
                    jj = k - j
                    kk = jb + jj
                    If kk > Idiag0(k - 1) Then
                        s = s + Tk(kk) * TfD(jj)
                    End If
                Next j
            End If
            buf(k) = s
        Next k

        For k = 1 To Nall
            TfD(k) = buf(k)
        Next k

        For ib = 1 To Nbound
            If Ntype < 3 Then
                j = Ndim * (Kcomp(Nrest(ib)) - 1)
                If Ntype = 1 Then
                    nb = 2
                Else
                    nb = 3
                End If
            Else
                k = Nrest(ib)
                j = Lr(k) - 1
                nb = NvarP(Kcomp(k))
            End If
            For id = 1 To nb
                If Jdirect(ib, id) > 0 Then
                    k = j + id
                    b1 = TfD(k)
                    TfD(k) = Fdirect(ib, id)
                    FdirOut(ib, id) = b1 - TfD(k)
                End If
            Next id
        Next ib

        aa$ = a1$ + "節点番号、Ｘ方向の力、Ｙ方向の力"
        If Ntype > 1 Then
            aa$ = aa$ + "、θ回りモーメント"
        End If
        SwK.WriteLine("----------------------------------------------")
        SwK.WriteLine("＊＊ 全節点の荷重出力 ＊＊")
        SwK.WriteLine(aa$)
        For ip = 1 To Npoint
            If Ntype < 3 Then
                jj = Ndim * (Kcomp(ip) - 1)
                If Ntype = 1 Then
                    nb = 2
                Else
                    nb = 3
                End If
            Else
                jj = Lr(ip) - 1
                nb = NvarP(Kcomp(ip))
            End If
            Call ForceOut2(ip, jj, nb, c1) '力等の出力
        Next ip

        SwK.WriteLine("----------------------------------------------")
        SwK.WriteLine("＊＊ 拘束節点の反力 ＊＊")
        SwK.WriteLine(aa$)
        For ib = 1 To Nbound
            ip = Nrest(ib)
            If Ntype < 3 Then
                j = Ndim * (Kcomp(ip) - 1)
                If Ntype = 1 Then
                    nb = 2
                Else
                    nb = 3
                End If
            Else
                j = Lr(ip) - 1
                nb = NvarP(Kcomp(ip))
            End If
            For id = 1 To nb
                k = j + id
                TfD(k) = FdirOut(ib, id)
            Next id
            Call ForceOut2(ip, j, nb, c1) '力等の出力
        Next ib

    End Sub

    Private Sub ForceOut(ByVal ie As Integer, ByVal ii As Integer, _
        ByVal jj As Integer, ByVal c1 As Single, ByVal zbuf() As Single)
        '軸力等の出力
        'ii･･･節点番号
        'jj･･･軸力等配列のﾍﾞｰｽ値(0またはNdim)
        'c1･･･時間または角度
        'zbuf()･･･各応力
        Dim aa$
        Dim j As Integer
        Dim z1 As Single

        aa$ = Str$(c1) + ",  " + Str(ie) + ",  " + Str(ii) + ",  " + Str(zbuf(0))
        For j = 1 To 2
            z1 = EForce(jj + j)
            aa$ = aa$ + ",  " + Str(z1)
        Next j
        Select Case Ntype
            Case 1
                aa$ = aa$ + ",  " + Str(zbuf(1))
            Case Else
                z1 = EForce(jj + 3)
                aa$ = aa$ + ",  " + Str(z1)
                For j = 1 To 5
                    If j = 1 Then
                        aa$ = aa$ + ",     " + Str(zbuf(j))
                    Else
                        aa$ = aa$ + ",  " + Str(zbuf(j))
                    End If
                Next j
        End Select
        SwK.WriteLine(aa$)

    End Sub

    Private Sub ForceOut2(ByVal ip As Integer, ByVal jj As Integer, _
    ByVal nb As Integer, ByVal c1 As Single)
        '力等の出力
        'ip･･･節点番号
        'jj･･･力等配列のﾍﾞｰｽ値
        'nb･･･変位の数
        'c1･･･時間または角度
        Dim aa$
        Dim i As Integer
        Dim z1 As Single

        aa$ = Str$(c1) + ",  " + Str$(ip)
        For i = 1 To nb
            z1 = TfD(jj + i)
            aa$ = aa$ + ",  " + Str$(z1)
        Next i
        SwK.WriteLine(aa$)

    End Sub

    Private Sub HLoadSet()
        '分布荷重の設定
        '軸力等は初期内力として処理
        Dim i, ib, ii, k, ke As Integer
        Dim b1, b2, cc, cs, fnorm, ftang, rlen, rmoment As Single
        Dim kbuf(2), kebuf(2) As Integer

        For i = 1 To Nsurf
            ke = KEsurf(i)
            For ii = 1 To 2
                ib = NNelem(ke, ii)
                kbuf(ii) = ib
                XE(ii) = X(ib)
                YE(ii) = Y(ib)
            Next ii
            b1 = XE(2) - XE(1)
            b2 = YE(2) - YE(1)
            rlen = Math.Sqrt(b1 * b1 + b2 * b2)
            cs = b2 / rlen
            cc = b1 / rlen

            fnorm = 0.5 * Pnorm(i) * rlen
            ftang = 0.5 * Ptang(i) * rlen
            rmoment = fnorm * rlen / 6

            For ii = 1 To 2
                ib = NNelem(ke, ii)
                'k = Ndim * (ib - 1)
                k = Ndim * (Kcomp(ib) - 1)
                TfD(k + 1) = TfD(k + 1) - fnorm * cs + ftang * cc
                TfD(k + 2) = TfD(k + 2) + fnorm * cc + ftang * cs
                If Ntype = 2 Then
                    If ii = 1 Then
                        b1 = rmoment
                    Else
                        b1 = -rmoment
                    End If
                    TfD(k + 3) = TfD(k + 3) + b1
                End If
            Next ii

            BarForce(ke, 1) = ftang
            BarForce(ke, 2) = -ftang
            BarShear(ke, 1) = -fnorm
            BarShear(ke, 2) = fnorm
            If Ntype = 2 Then
                BarMoment(ke, 1) = rmoment
                BarMoment(ke, 2) = rmoment
            End If
        Next i

    End Sub

    Private Sub HLoadSet2()
        '分布荷重の設定2
        '軸力等は初期内力として処理
        Dim i, ib, ii, k, ke As Integer
        Dim b1, b2, cc, cs, ftang, rlen, rmoment As Double
        Dim fnorm(2) As Double

        For i = 1 To Nsurf
            ke = KEsurf(i)
            For ii = 1 To 2
                ib = NNelem(ke, ii)
                XE(ii) = X(ib)
                YE(ii) = Y(ib)
            Next ii
            b1 = XE(2) - XE(1)
            b2 = YE(2) - YE(1)
            rlen = Math.Sqrt(b1 * b1 + b2 * b2)
            cs = b2 / rlen
            cc = b1 / rlen

            Select Case KindElem(ke)
                Case 3
                    fnorm(1) = 3 * Pnorm(i) * rlen / 8
                    fnorm(2) = 5 * Pnorm(i) * rlen / 8
                    rmoment = Pnorm(i) * rlen * rlen / 8
                Case 4
                    fnorm(1) = 5 * Pnorm(i) * rlen / 8
                    fnorm(2) = 3 * Pnorm(i) * rlen / 8
                    rmoment = Pnorm(i) * rlen * rlen / 8
                Case Else
                    fnorm(1) = 0.5 * Pnorm(i) * rlen
                    fnorm(2) = fnorm(1)
                    rmoment = fnorm(1) * rlen / 6
            End Select
            ftang = 0.5 * Ptang(i) * rlen

            For ii = 1 To 2
                ib = NNelem(ke, ii)
                k = Lr(ib) - 1
                TfD(k + 1) = TfD(k + 1) - fnorm(ii) * cs + ftang * cc
                TfD(k + 2) = TfD(k + 2) + fnorm(ii) * cc + ftang * cs
                If KindElem(ke) = 2 Or KindElem(ke) = 4 Then
                    If ii = 1 Then
                        TfD(k + 3) = TfD(k + 3) + rmoment
                    End If
                End If
                If KindElem(ke) = 2 Or KindElem(ke) = 3 Then
                    If ii = 2 Then
                        TfD(k + 3) = TfD(k + 3) - rmoment
                    End If
                End If
            Next ii

            BarForce(ke, 1) = ftang
            BarForce(ke, 2) = -ftang
            BarShear(ke, 1) = -fnorm(1)
            BarShear(ke, 2) = fnorm(2)
            If KindElem(ke) = 2 Or KindElem(ke) = 4 Then
                BarMoment(ke, 1) = rmoment
            End If
            If KindElem(ke) = 2 Or KindElem(ke) = 3 Then
                BarMoment(ke, 2) = rmoment
            End If
        Next i

    End Sub

    Private Sub InitAdjust(ByVal nx As Integer)
        '初期値調整
        'nx･･･次数
        Dim i As Integer
        Dim alp, b1 As Single

        alp = 0.6
        b1 = 1 - alp
        For i = 1 To nx
            If KAccSet(i) = 0 Then
                Accel2(i) = alp * Accel0(i) + b1 * Accel2(i)
                Disp2(i) = alp * Disp0(i) + b1 * Disp2(i)
                Vel2(i) = alp * Vel0(i) + b1 * Vel2(i)
            End If
            Accel0(i) = Accel2(i)
            Disp0(i) = Disp2(i)
            Vel0(i) = Vel2(i)
        Next i

    End Sub

    Private Sub InitBase()
        '初期ﾍﾞｰｽ設定
        Dim ii, ip, j, nb As Integer

        If Ntype = 1 Then
            Nvar = 4
        Else
            Nvar = 6
        End If

        Nall = Ndim * Npoint
        ReDim TfD(Nall), TfS(Nall)
        ReDim Kdispmb(Nall), Nodemb(Nall)
        ReDim Ek(Nvar, Nvar), Ekb(Nvar, Nvar), Trans(Nvar, Nvar)
        ReDim Em(Nvar, Nvar), Emb(Nvar, Nvar)
        ReDim EForce(Nvar), Efb(Nvar)
        ReDim NPrefer(Nvar)
        ReDim BarForce(Nelem, 2), BarShear(Nelem, 2), BarMoment(Nelem, 2)
        ReDim Fdirect(Nbound, 3), FdirOut(Nbound, 3)

        If Ntype < 3 Then
            '行列の変数番号の対応設定
            For ip = 1 To Npoint
                ii = Ndim * (ip - 1)
                For j = 1 To Ndim
                    ii = ii + 1
                    Nodemb(ii) = ip
                Next j
            Next ip
        Else
            ReDim LrD(Npoint), NvarPD(Npoint)
            Call NvarPDSet()     '元ﾃﾞｰﾀ節点の変数の数を設定
            Nall = LrD(Npoint) - 1 + NvarPD(Npoint)
            ReDim Lr(Npoint)
            nb = 0
            For ip = 1 To Npoint '計算順節点
                For j = 1 To Npoint '元ﾃﾞｰﾀ節点
                    If Kcomp(j) = ip Then
                        Lr(j) = nb + 1
                        nb = nb + NvarP(ip)
                        Exit For
                    End If
                Next j
            Next ip
        End If

        If KAnal = 0 Then
            Call RoundPrep2(KindTime, NbTime, DTime) '丸め準備2
        End If

    End Sub

    Private Sub InitialSet1S()
        '初期設定（静荷重用）

        If Nforce > 0 Then
            If Ntype < 3 Then
                Call FLoadSet() '節点荷重の設定
            Else
                Call FLoadSet2() '節点荷重の設定2
            End If
        End If

        If Nsurf > 0 Then
            If Ntype < 3 Then
                Call HLoadSet() '分布荷重の設定
            Else
                Call HLoadSet2() '分布荷重の設定2
            End If
        End If

    End Sub

    Private Sub InitialSet2S(ByVal mb As Integer)
        '初期設定2S（静荷重用）
        Dim aa$
        Dim i, ib, ic, id, ie, ii, ip, j, j1, jb, k, k1, k2, nb, num, numall As Integer
        Dim nbuf(Npoint) As Integer

        '関連節点数の計算
        numall = 0
        nb = Ndim * (Ndim - 1) / 2
        For i = 1 To Npoint
            j1 = i - mb + 1
            If j1 < 0 Then
                j1 = 1
            End If
            For j = j1 To i
                nbuf(j) = 0
            Next j
            ip = KRcomp(i)
            For ie = 1 To Nelem
                ic = 0
                For ii = 1 To 2
                    If NNelem(ie, ii) = ip Then
                        ic = 1
                        Exit For
                    End If
                Next ii
                If ic > 0 Then
                    For ii = 1 To 2
                        ib = Kcomp(NNelem(ie, ii))
                        If ib <= i Then
                            nbuf(ib) = 1
                        End If
                    Next ii
                End If
            Next ie
            If Nspring > 0 Then
                For j = 1 To Nspring
                    k1 = KPspring(j, 1)
                    k2 = KPspring(j, 2)
                    If k1 = ip Then
                        If k2 > 0 Then
                            ib = Kcomp(k2)
                            If ib <= i Then
                                nbuf(ib) = 1
                            End If
                        End If
                    ElseIf k2 = ip Then
                        ib = Kcomp(k1)
                        If ib <= i Then
                            nbuf(ib) = 1
                        End If
                    End If
                Next j
            End If
            If Ndamp > 0 Then
                For j = 1 To Ndamp
                    k1 = KPdamp(j, 1)
                    k2 = KPdamp(j, 2)
                    If k1 = ip Then
                        If k2 > 0 Then
                            ib = Kcomp(k2)
                            If ib <= i Then
                                nbuf(ib) = 1
                            End If
                        End If
                    ElseIf k2 = ip Then
                        ib = Kcomp(k1)
                        If ib <= i Then
                            nbuf(ib) = 1
                        End If
                    End If
                Next j
            End If

            jb = 0
            For j = j1 To i
                If nbuf(j) > 0 Then
                    jb = j
                    Exit For
                End If
            Next j
            If jb = 0 Then
                aa$ = "対象列が見当たらないエラーが発生しました！"
                MsgBox(aa$, 0, "計算エラー")
                End
            End If
            If Ntype < 3 Then
                num = i - jb + 1
                numall = numall + num * Ndim * Ndim - nb
            Else
                num = 0
                For id = 1 To NvarP(i)
                    nb = nb + 1
                    For j = jb To i
                        If j < i Then
                            num = num + NvarP(j)
                        Else
                            num = num + id
                        End If
                    Next j
                Next id
                numall = numall + num
            End If
        Next i
        NumEff = numall
        NumEff0 = numall

        ReDim Tk(NumEff), RKmatb(NumEff), RMmatb(NumEff)
        ReDim Idiag(Nall), Idiag0(Nall)

        '保存配列との関連付け
        numall = 0
        nb = 0
        For i = 1 To Npoint
            j1 = i - mb + 1
            If j1 < 0 Then
                j1 = 1
            End If
            For j = j1 To i
                nbuf(j) = 0
            Next j
            ip = KRcomp(i)
            For ie = 1 To Nelem
                ic = 0
                For ii = 1 To 2
                    If NNelem(ie, ii) = ip Then
                        ic = 1
                        Exit For
                    End If
                Next ii
                If ic > 0 Then
                    For ii = 1 To 2
                        ib = Kcomp(NNelem(ie, ii))
                        If ib <= i Then
                            nbuf(ib) = 1
                        End If
                    Next ii
                End If
            Next ie
            If Nspring > 0 Then
                For j = 1 To Nspring
                    k1 = KPspring(j, 1)
                    k2 = KPspring(j, 2)
                    If k1 = ip Then
                        If k2 > 0 Then
                            ib = Kcomp(k2)
                            If ib <= i Then
                                nbuf(ib) = 1
                            End If
                        End If
                    ElseIf k2 = ip Then
                        ib = Kcomp(k1)
                        If ib <= i Then
                            nbuf(ib) = 1
                        End If
                    End If
                Next j
            End If
            If Ndamp > 0 Then
                For j = 1 To Ndamp
                    k1 = KPdamp(j, 1)
                    k2 = KPdamp(j, 2)
                    If k1 = ip Then
                        If k2 > 0 Then
                            ib = Kcomp(k2)
                            If ib <= i Then
                                nbuf(ib) = 1
                            End If
                        End If
                    ElseIf k2 = ip Then
                        ib = Kcomp(k1)
                        If ib <= i Then
                            nbuf(ib) = 1
                        End If
                    End If
                Next j
            End If

            jb = 0
            For j = j1 To i
                If nbuf(j) > 0 Then
                    jb = j
                    Exit For
                End If
            Next j

            If Ntype < 3 Then
                For id = 1 To Ndim
                    nb = nb + 1
                    For j = jb To i
                        If j = i Then
                            k2 = id
                        Else
                            k2 = Ndim
                        End If
                        For k = 1 To k2
                            numall = numall + 1
                        Next k
                    Next j
                    Idiag(nb) = numall
                Next id
            Else
                For id = 1 To NvarP(i)
                    nb = nb + 1
                    For j = jb To i
                        If j < i Then
                            numall = numall + NvarP(j)
                        Else
                            numall = numall + id
                        End If
                    Next j
                    Idiag(nb) = numall
                Next id
            End If
        Next i

        For i = 1 To Nall
            Idiag0(i) = Idiag(i)
        Next i

    End Sub

    Private Sub LoadVibNew(ByRef kh As Integer, ByRef itime As Integer)
        '振動外力区間の新規設定
        'kh･･･振動外力終了の有無（0:なし、1:有り）
        'itime･･･振動外力のﾒｯｼｭ番号
        Dim i, ib, j, na, nb As Integer
        kh = 0
        If itime <= NvibTime Then
            nb = 0
            For i = 1 To NPvib
                If Ntype < 3 Then
                    na = Ndim
                Else
                    ib = KPvib(i)
                    na = NvarPD(ib)
                End If
                For j = 1 To na
                    If JLoadVib(i, j) > 0 Then
                        nb = nb + 1
                        FLoadVib(i, j) = FLvibTime(itime, nb)
                    End If
                Next j
            Next i
            itime = itime + 1
        Else
            kh = 1
        End If

    End Sub

    Private Sub LoadVibSet(ByRef kh As Integer, ByVal kind As Integer, _
        ByVal istep As Integer, ByVal nstepb As Integer)
        '振動外力の設定
        'kh･･･振動外力終了の有無（0:なし、1:有り、-1以下:不要）
        'kind･･･外力区分（0:力、1:加速度）
        'istep･･･計算時間ﾒｯｼｭ番号
        'nstepb･･･振動外力時間間隔の倍数
        Dim i, ib, ii, j, k, na As Integer
        Dim b1, b2, b3 As Single

        Select Case kh
            Case Is >= 0
                If kh = 0 Then
                    b1 = istep Mod nstepb
                    b2 = b1 / nstepb
                    b1 = 1 - b2
                End If
                For i = 1 To NPvib
                    If Ntype < 3 Then
                        ii = Ndim * (KPvib(i) - 1)
                        na = Ndim
                    Else
                        ib = KPvib(i)
                        ii = LrD(ib) - 1
                        na = NvarPD(ib)
                    End If
                    For j = 1 To na
                        If JLoadVib(i, j) > 0 Then
                            If kh = 0 Then
                                b3 = b1 * FLoadVibI(i, j) + b2 * FLoadVib(i, j)
                            Else
                                b3 = FLoadVib(i, j)
                            End If
                            FLoadVibX(i, j) = b3
                            k = Lcomp(ii + j)
                            If k > 0 Then
                                If kind = 0 Then
                                    TfD(k) = b3
                                Else
                                    Accel2(k) = b3
                                End If
                            End If
                        End If
                    Next j
                Next i
                If kh = 1 Then
                    kh = -1
                End If
            Case Else
                If kind = 1 Then
                    For i = 1 To Norder
                        KAccSet(i) = 0
                    Next i
                End If
                kh = -2
                KVibOff = 1
        End Select

    End Sub

    Private Sub LoadVibSet2(ByVal kind As Integer, ByVal istep As Integer)
        '振動外力の設定
        'kind･･･外力区分（0:力、1:加速度）
        'istep･･･ｻｲｸﾙ分割番号
        Dim i, ib, ii, j, k, n, na As Integer
        Dim b3, c1, c2, c3, c4, omega As Single

        omega = Dpai * FreqLVib
        If istep < NdivCyc Then
            c1 = Dpai * istep / NdivCyc
        Else
            c1 = 0
        End If
        c4 = Pai / 180
        n = 0
        For i = 1 To NPvib
            If Ntype < 3 Then
                ii = Ndim * (KPvib(i) - 1)
                na = Ndim
            Else
                ib = KPvib(i)
                ii = LrD(ib) - 1
                na = NvarPD(ib)
            End If
            For j = 1 To na
                If JLoadVib(i, j) > 0 Then
                    n = n + 1
                    c2 = Math.Sin(c1 + c4 * DataFreq(n, 2))
                    c3 = Math.Cos(c1 + c4 * DataFreq(n, 2))
                    b3 = DataFreq(n, 1) * c2
                    FLoadVibX(i, j) = b3
                    k = Lcomp(ii + j)
                    If k > 0 Then
                        If kind = 0 Then
                            TfD(k) = b3
                        Else
                            Accel2(k) = b3
                            Vel2(k) = -DataFreq(n, 1) * c3 / omega
                            Disp2(k) = -b3 / (omega * omega)
                        End If
                    End If
                End If
            Next j
        Next i

    End Sub

    Private Sub MatMaxCalc()
        '行列要素の最大値計算
        Dim i, ii As Integer

        For i = 1 To Norder
            ii = Idiag(i)
            If RMmatb(ii) > RMmax Then
                RMmax = RMmatb(ii)
            End If
            If RKmatb(ii) > RKmax Then
                RKmax = RKmatb(ii)
            End If
            If KindVEqua > 0 Then
                If Cmatb(ii) > Cmax Then
                    Cmax = Cmatb(ii)
                End If
            End If
        Next i

    End Sub

    Private Sub MatrixReduct()
        '行列の縮減
        Dim i, ib, id, ii, j, jj, k, k2, kb, kk, kx, na, nb, ndel As Integer
        ReDim Lcomp(Nall)

        For i = 1 To Npoint
            If Ntype < 3 Then
                j = Ndim * (i - 1)
                k = Ndim * (Kcomp(i) - 1)
                na = Ndim
            Else
                j = LrD(i) - 1
                k = Lr(i) - 1
                na = NvarPD(i)
            End If
            For id = 1 To na
                j = j + 1
                k = k + 1
                Lcomp(j) = k
            Next id
        Next i

        nb = Nall
        ii = 0
        For i = 1 To Nall
            If Nodemb(i) = 0 Then
                kb = Lcomp(i)
                For k = 1 To Nall
                    If Lcomp(k) > kb Then
                        Lcomp(k) = Lcomp(k) - 1
                    End If
                Next k
                Lcomp(i) = 0
                k2 = kb + Mband - 1
                If k2 > nb Then
                    k2 = nb
                End If
                For k = k2 To kb + 1 Step -1
                    ib = k - kb
                    kx = Idiag(k) - ib
                    If kx > Idiag(k - 1) Then
                        For j = kx + 1 To NumEff
                            RKmatb(j - 1) = RKmatb(j)
                            RMmatb(j - 1) = RMmatb(j)
                        Next j
                        RKmatb(NumEff) = 0
                        RMmatb(NumEff) = 0
                        NumEff = NumEff - 1
                        For kk = k To nb
                            Idiag(kk) = Idiag(kk) - 1
                        Next kk
                    End If
                Next k
                ndel = Idiag(kb) - Idiag(kb - 1)
                If kb < nb Then
                    For j = Idiag(kb) + 1 To NumEff
                        RKmatb(j - ndel) = RKmatb(j)
                        RMmatb(j - ndel) = RMmatb(j)
                    Next j
                    For k = kb + 1 To nb
                        Idiag(k - 1) = Idiag(k) - ndel
                    Next k
                End If
                For j = 1 To ndel
                    RKmatb(NumEff - j + 1) = 0
                    RMmatb(NumEff - j + 1) = 0
                Next j
                nb = nb - 1
                NumEff = NumEff - ndel
            End If
        Next i

        ReDim KAccSet(Norder), KDispSet(Norder)
        If KindLvib = 1 Then
            For i = 1 To NPvib
                k = KPvib(i)
                If Ntype < 3 Then
                    ii = Ndim * (k - 1)
                    na = Ndim
                Else
                    ii = LrD(k) - 1
                    na = NvarPD(k)
                End If
                For j = 1 To na
                    If JLoadVib(i, j) > 0 Then
                        KAccSet(Lcomp(ii + j)) = 1
                        If KAnal = 1 Then
                            KDispSet(Lcomp(ii + j)) = 1
                        End If
                    End If
                Next j
            Next i
        End If

        If KAnal = 1 Then
            ReDim KcheckP(Norder)
            If KindLvib = 1 Then
                Dim ic, ie As Integer
                For i = 1 To NPvib
                    For j = 1 To Ndim
                        If JLoadVib(i, j) > 0 Then
                            For ie = 1 To Nelem
                                ic = 0
                                For jj = 1 To 2
                                    If NNelem(ie, jj) = KPvib(i) Then
                                        ic = 1
                                        Exit For
                                    End If
                                Next jj
                                If ic > 0 Then
                                    For jj = 1 To 2
                                        k = NNelem(ie, jj)
                                        If Ntype < 3 Then
                                            ii = Ndim * (k - 1)
                                            na = Ndim
                                        Else
                                            ii = LrD(k) - 1
                                            na = NvarPD(k)
                                        End If
                                        For k = 1 To na
                                            KcheckP(Lcomp(ii + k)) = 1
                                        Next k
                                    Next jj
                                End If
                            Next ie
                        End If
                    Next j
                Next i
            End If
        End If

    End Sub

    Private Sub MiniSort2(ByVal kind As Integer, ByRef nsort() As Integer, _
ByVal work() As Single, ByVal xbuf() As Single, ByVal ybuf() As Single)
        'ﾐﾆｿｰﾄ2
        '同じ変数値の場合に、第2座標値でソート
        'kind･･･主ｿｰﾄの座標軸番号（1:X軸、2:Y軸）
        'nsort()･･･元の変数番号のｿｰﾄ順番号
        'work()･･･ｿｰﾄ変数値
        'xbuf(),ybuf()･･･節点の座標
        Dim i, j, jb, jx, nb, n1, n2, nx As Integer
        Dim b1 As Single
        Dim nsort2(10) As Integer
        Dim work2(10) As Single

        i = 1
        Do
            If work(i) = work(i + 1) Then
                b1 = work(i)
                n1 = i
                For j = i + 1 To Npoint
                    If b1 = work(j) Then
                        n2 = j
                    Else
                        Exit For
                    End If
                Next j
                nx = n2 - n1 + 1
                ReDim nsort2(nx), work2(nx)
                jb = 0
                For j = n1 To n2
                    jb = jb + 1
                    nsort2(jb) = jb
                    nb = nsort(j)
                    If kind = 1 Then
                        work2(jb) = ybuf(nb)
                    Else
                        work2(jb) = xbuf(nb)
                    End If
                Next j
                Call ShellSortStd(nx, nsort2, work2)    'ｼｪｯﾙｿｰﾄ基本
                For j = 1 To nx
                    jb = n1 + nsort2(j) - 1
                    nsort2(j) = nsort(jb)
                Next j
                For j = 1 To nx
                    jx = n1 + j - 1
                    nsort(jx) = nsort2(j)
                Next j
                i = n2 + 1
            Else
                i = i + 1
            End If
        Loop While i < Npoint

    End Sub

    Private Sub MmatSet()
        'Ｍ行列の設定
        Dim i, ii, j As Integer

        ii = 0
        For i = 1 To Nall
            If Nodemb(i) > 0 Then
                ii = ii + 1
                j = Lcomp(i)
                RMmatb(Idiag(j)) = RMmatrix(ii)
            End If
        Next i

    End Sub

    Private Sub NewStep(ByVal nx As Integer)  '新ｽﾃｯﾌﾟ準備
        'nx･･･次数
        Dim i As Integer
        For i = 1 To nx
            Accel1(i) = Accel2(i)
            Disp1(i) = Disp2(i)
            Vel1(i) = Vel2(i)
            Accel2(i) = 0
            Disp2(i) = 0
            Vel2(i) = 0
        Next i

    End Sub

    Private Sub NvarPSet()
        '各節点順の変数の数を設定
        Dim i, j, k As Integer
        For i = 1 To Npoint
            NvarP(Kcomp(i)) = 2
        Next i
        For i = 1 To Nelem
            If KindElem(i) > 1 Then
                For j = 1 To 2
                    k = NNelem(i, j)
                    NvarP(Kcomp(k)) = 3
                Next j
            End If
        Next i

    End Sub

    Private Sub NvarPSet2(ByVal kcbuf() As Integer, ByRef nvarb() As Integer)
        '各節点順の変数の数を設定
        'kcbuf()･･･元の節点の変数順序
        'nvarb()･･･各節点順の変数の数
        Dim i, j, k As Integer

        For i = 1 To Npoint
            nvarb(kcbuf(i)) = 2
        Next i
        For i = 1 To Nelem
            If KindElem(i) > 1 Then
                For j = 1 To 2
                    k = NNelem(i, j)
                    nvarb(kcbuf(k)) = 3
                Next j
            End If
        Next i

    End Sub

    Private Sub PnumImproveNew(ByRef mb As Integer, ByVal xbuf() As Single, ByVal ybuf() As Single)
        '節点付番の改良
        'mb･･･改良後のﾊﾞﾝﾄﾞ幅
        'xbuf(),ybuf()･･･節点の座標
        Dim i, ib, k, kx, mbb, mbx As Integer
        Dim kcbuf(Npoint), nvarb(Npoint) As Integer
        ReDim Kcomp(Npoint), KRcomp(Npoint), NvarP(Npoint)

        For i = 1 To Npoint
            Kcomp(i) = i
        Next i
        If Ntype = 3 Then
            Call NvarPSet2(Kcomp, NvarP)     '各節点順の変数の数を設定
        End If
        If Ntype < 3 Then
            Call BandWidth2(mbx, Kcomp)  'ﾊﾞﾝﾄﾞ幅の計算2
        Else
            Call BandWidth3(mbx, Kcomp, NvarP)  'ﾊﾞﾝﾄﾞ幅の計算3
        End If

        For k = 1 To 2
            Call ShellSort2(k, kcbuf, xbuf, ybuf)    'ｼｪﾙｿｰﾄ2
            If Ntype = 3 Then
                Call NvarPSet2(kcbuf, nvarb)     '各節点順の変数の数を設定
            End If
            If Ntype < 3 Then
                Call BandWidth2(mb, kcbuf)  'ﾊﾞﾝﾄﾞ幅の計算2
            Else
                Call BandWidth3(mb, kcbuf, nvarb)  'ﾊﾞﾝﾄﾞ幅の計算3
            End If
            If k = 1 Then
                kx = 1
                mbb = mb
            ElseIf mb < mbb Then
                kx = k
                mbb = mb
            End If
        Next k

        If mbb < mbx Then
            Call ShellSort2(kx, kcbuf, xbuf, ybuf)    'ｼｪﾙｿｰﾄ2
            If Ntype = 3 Then
                Call NvarPSet2(kcbuf, nvarb)     '各節点順の変数の数を設定
            End If
            If Ntype < 3 Then
                Call BandWidth2(mb, kcbuf)  'ﾊﾞﾝﾄﾞ幅の計算2
            Else
                Call BandWidth3(mb, kcbuf, nvarb)  'ﾊﾞﾝﾄﾞ幅の計算3
            End If
            For i = 1 To Npoint
                Kcomp(i) = kcbuf(i)
            Next i
            If Ntype = 3 Then
                For i = 1 To Npoint
                    NvarP(i) = nvarb(i)
                Next i
            End If
        Else
            mb = mbx
        End If

        For i = 1 To Npoint
            ib = Kcomp(i)
            KRcomp(ib) = i
        Next i

    End Sub

    Private Sub ReqTime(ByVal crate As Single, ByVal rmesh As Single, _
    ByVal b1 As Single)
        '残りの所要時間の計算
        'crate･･･調整係数
        'rmesh･･･残存ﾒｯｼｭ数
        'b1･･･計算の時間差（秒単位）
        Dim aa$, tima$
        Dim b2 As Single
        Dim gr As Graphics = PictureBox2.CreateGraphics

        tima$ = ""
        If b1 < 0 Then
            b1 = b1 + 86400
        End If
        b2 = b1 * rmesh / crate
        Call TimConv(tima$, b2)
        aa$ = "残り " & tima$
        gr.Clear(Color.White)
        gr.DrawString(aa$, New Font("ＭＳ ゴシック", 9), Brushes.Black, 1, 1)
        gr.Dispose()

    End Sub

    Private Sub ResFile1U()
        '結果ﾌｧｲﾙへの出力
        'UTF-8･･･BOMなし
        Dim a1$, aa$, ad$

        SwK = New IO.StreamWriter(Fy$)  '結果出力用
        If KindVEqua = 0 Then
            a1$ = "ＭＫ型"
        Else
            a1$ = "ＭＣＫ型"
        End If
        aa$ = "＜＜" + a1$ + "部材２Ｄ振動応答解析の結果＞＞"
        SwK.WriteLine(aa$)
        SwK.WriteLine(Title$)
        aa$ = "［入力ﾃﾞｰﾀﾌｧｲﾙ］" + "," + Fm$
        SwK.WriteLine(aa$)
        If KAnal = 0 Then
            aa$ = "一般応答"
        Else
            aa$ = "周波数応答"
        End If
        aa$ = "解析種類：" + aa$
        SwK.WriteLine(aa$)
        If KindSLoad = 0 Then
            SwK.WriteLine("静荷重なし")
        Else
            SwK.WriteLine("静荷重有り")
        End If

        aa$ = "＜パラメーター条件＞"
        SwK.WriteLine(aa$)
        If KAnal = 0 Then
            aa$ = "計算打切り時間" + "," + Str(TimeMax)
            SwK.WriteLine(aa$)
            aa$ = "計算時間間隔" + ", " + Str(DTime)
            SwK.WriteLine(aa$)
            aa$ = "振動外力時間間隔の倍率" + "," + Str(NstepF)
            SwK.WriteLine(aa$)
            aa$ = "出力時間間隔の倍率" + "," + Str(Nstep)
            SwK.WriteLine(aa$)
        Else
            aa$ = "最大繰返し数" + "," + Str(NKmax)
            SwK.WriteLine(aa$)
            aa$ = "１周期分割数" + "," + Str(NdivCyc)
            SwK.WriteLine(aa$)
            aa$ = "収束判定誤差比率" + "," + Str(EpsCalc)
            SwK.WriteLine(aa$)
        End If
        ad$ = "-------------------------------------------------------"
        SwK.WriteLine(ad$)
        SwK.WriteLine("＊＊＊ 計算結果 ＊＊＊")
        aa$ = "Ｍ行列要素の最大値" + "," + Str(RMmax)
        SwK.WriteLine(aa$)
        If KindVEqua = 1 Then
            aa$ = "Ｃ行列要素の最大値" + "," + Str(Cmax)
            SwK.WriteLine(aa$)
        End If
        aa$ = "Ｋ行列要素の最大値" + "," + Str(RKmax)
        SwK.WriteLine(aa$)

    End Sub

    Private Sub ResFile2U(ByVal kh As Integer, ByVal istep As Integer)
        '結果ﾌｧｲﾙへの出力2
        'UTF-8･･･BOMなし
        'kh･･･振動外力ﾃﾞｰﾀの有無（-1以上:有り、-2:なし）
        'istep･･･時間ﾒｯｼｭ番号
        Dim a1$, aa$, ad$
        Dim i, id, ii, j, k, nb As Integer
        Dim b1, c1, zb As Single
        Dim zbuf(3) As Single

        ad$ = "-------------------------------------------------------"
        SwK.WriteLine(ad$)
        If KAnal = 0 Then
            aa$ = "＜時間メッシュ番号、時間＞"
            aa$ = aa$ + "," + Str(istep) + "," + Str(TimeNew)
            SwK.WriteLine(aa$)
            a1$ = "時間、"
            c1 = TimeNew
        Else
            aa$ = "＜周期内メッシュ番号、角度、周期内時間＞"
            c1 = 360.0 * istep / NdivCyc
            b1 = DTime * istep
            aa$ = aa$ + "," + Str(istep) + "," + Str(c1) + "," + Str(b1)
            SwK.WriteLine(aa$)
            a1$ = "角度、"
        End If
        SwK.WriteLine("＜振動外力データ＞")
        If kh > -2 Then
            If KindLvib = 0 Then
                If Ntype = 1 Then
                    aa$ = a1$ + "節点番号、Ｘ方向の力、Ｙ方向の力"
                Else
                    aa$ = a1$ + "節点番号、Ｘ方向の力、Ｙ方向の力、θ回りモーメント"
                End If
            Else
                If Ntype = 1 Then
                    aa$ = a1$ + "節点番号、Ｘ方向の加速度、Ｙ方向の加速度"
                Else
                    aa$ = a1$ + "節点番号、Ｘ方向の加速度、Ｙ方向の加速度、θ角の加速度"
                End If
            End If
            SwK.WriteLine(aa$)
            For i = 1 To NPvib
                aa$ = Str$(c1) + ",  " + Str$(KPvib(i))
                For j = 1 To Ndim
                    b1 = FLoadVibX(i, j)
                    aa$ = aa$ + ",  " + Str$(b1)
                    If Math.Abs(b1) > Math.Abs(FLvibMax(j)) Then
                        FLvibMax(j) = b1
                        KFLvibMax(j) = KPvib(i)
                        TFLvibMax(j) = c1
                    End If
                Next j
                SwK.WriteLine(aa$)
            Next i
        Else
            SwK.WriteLine("  なし")
        End If

        SwK.WriteLine("＜変位データ＞")
        If Ntype = 1 Then
            aa$ = a1$ + "節点番号、δX、δY"
        Else
            aa$ = a1$ + "節点番号、δX、δY、θ"
        End If
        SwK.WriteLine(aa$)
        For i = 1 To Npoint
            aa$ = Str$(c1) + ",  " + Str$(i)
            If Ntype < 3 Then
                ii = Ndim * (i - 1)
                nb = Ndim
            Else
                ii = LrD(i) - 1
                nb = NvarPD(i)
            End If
            zb = 0
            For id = 1 To nb
                k = ii + id
                b1 = TfS(k) + Disp2(Lcomp(k))
                aa$ = aa$ + ",  " + Str$(b1)
                zbuf(id) = b1
                If id < 3 Then
                    zb = zb + b1 * b1
                End If
            Next id
            SwK.WriteLine(aa$)
            zbuf(0) = Math.Sqrt(zb)
            For id = 0 To nb
                If Math.Abs(zbuf(id)) > Math.Abs(DispMax(id)) Then
                    DispMax(id) = zbuf(id)
                    KDispMax(id) = i
                    TDispMax(id) = c1
                End If
            Next id
        Next i

    End Sub

    Private Sub ResFile3U(ByVal iconv As Integer)
        '結果ﾌｧｲﾙへの出力3
        'UTF-8･･･BOMなし
        'iconv･･･収束有無（0:なし、1:有り）
        Dim a1$, aa$, ad$
        Dim i, ic, imax, j, k, k1, k2, kmax As Integer

        a1$ = ""
        ad$ = "-------------------------------------------------------"
        SwK.WriteLine(ad$)
        If KAnal = 1 And iconv < 2 Then
            If iconv = 0 Then
                SwK.WriteLine("収束なし")
            Else
                SwK.WriteLine("最終回に収束有り")
            End If
            Exit Sub
        End If
        SwK.WriteLine("＜振動外力と変位の最大値データ＞")
        aa$ = "注）絶対値の最大。"
        SwK.WriteLine(aa$)
        CalcRes$ = "＜変位の最大値データ＞" + Cr$ + aa$
        aa$ = "変数項目、  最大値、          節点番号、"
        If KAnal = 0 Then
            aa$ = aa$ + "   時間"
        Else
            aa$ = aa$ + "   周期内角度"
        End If
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        For i = 1 To Ndim
            If FLvibMax(i) <> 0 Then
                Select Case i
                    Case 1
                        aa$ = "Ｆvx"
                    Case 2
                        aa$ = "Ｆvy"
                    Case 3
                        aa$ = "Ｍv"
                End Select
                aa$ = aa$ + ",  "
                aa$ = aa$ + Space$(10 - Len(aa$)) + Str$(FLvibMax(i)) + ",  "
                aa$ = aa$ + Space$(30 - Len(aa$)) + Str$(KFLvibMax(i)) + ",  "
                aa$ = aa$ + Space$(42 - Len(aa$)) + Str$(TFLvibMax(i))
                SwK.WriteLine(aa$)
            End If
        Next i
        For i = 0 To Ndim
            Select Case i
                Case 0
                    aa$ = "全δ"
                Case 1
                    aa$ = "δX"
                Case 2
                    aa$ = "δY"
                Case 3
                    aa$ = "θ"
            End Select
            aa$ = aa$ + ",  "
            aa$ = aa$ + Space$(10 - Len(aa$)) + Str$(DispMax(i)) + ",  "
            aa$ = aa$ + Space$(30 - Len(aa$)) + Str$(KDispMax(i)) + ",  "
            aa$ = aa$ + Space$(42 - Len(aa$)) + Str$(TDispMax(i))
            SwK.WriteLine(aa$)
            If i < 3 Then
                CalcRes$ = CalcRes$ + Cr$ + aa$
            End If
        Next i

        If Ntype = 1 Then
            kmax = 3
        Else
            kmax = 6
            For j = 4 To 6 Step 2
                If j = 4 Then
                    k = 4
                    k1 = 4
                    k2 = 5
                Else
                    k = 5
                    k1 = 6
                    k2 = 7
                End If
                If Zfmax(j) > Zfmax(j + 1) Then
                    ic = 0
                Else
                    ic = 1
                End If
                If ic = 0 Then
                    Zfmax(k) = Zfmax(k1)
                    KEfmax(k) = KEfmax(k1)
                    KPfmax(k) = KPfmax(k1)
                    Tfmax(k) = Tfmax(k1)
                Else
                    Zfmax(k) = Zfmax(k2)
                    KEfmax(k) = KEfmax(k2)
                    KPfmax(k) = KPfmax(k2)
                    Tfmax(k) = Tfmax(k2)
                End If
                If Zfmin(j) < Zfmin(j + 1) Then
                    ic = 0
                Else
                    ic = 1
                End If
                If ic = 0 Then
                    Zfmin(k) = Zfmin(k1)
                    KEfmin(k) = KEfmin(k1)
                    KPfmin(k) = KPfmin(k1)
                    Tfmin(k) = Tfmin(k1)
                Else
                    Zfmin(k) = Zfmin(k2)
                    KEfmin(k) = KEfmin(k2)
                    KPfmin(k) = KPfmin(k2)
                    Tfmin(k) = Tfmin(k2)
                End If
            Next j
            Zfmax(6) = Zfmax(8)
            KEfmax(6) = KEfmax(8)
            KPfmax(6) = KPfmax(8)
            Tfmax(6) = Tfmax(8)
        End If

        SwK.WriteLine(ad$)
        SwK.WriteLine("＜応力・軸力等の最大・最小値データ＞")
        aa$ = "注）正負の最大、最小。"
        SwK.WriteLine(aa$)
        If Ntype = 1 Then
            imax = 3
            k1 = 2
        Else
            imax = 6
            k1 = 3
        End If
        CalcRes$ = CalcRes$ + Cr$ + "＜応力の最大・最小値データ＞"
        CalcRes$ = CalcRes$ + Cr$ + aa$
        aa$ = "変数項目、    変数値、          要素番号、  節点番号、"
        If KAnal = 0 Then
            aa$ = aa$ + "   時間"
        Else
            aa$ = aa$ + "   周期内角度"
        End If
        SwK.WriteLine(aa$)
        CalcRes$ = CalcRes$ + Cr$ + aa$
        For i = 0 To imax
            Select Case i
                Case 0
                    a1$ = "軸σf "
                Case 1
                    a1$ = "軸力 "
                Case 2
                    a1$ = "剪断力 "
                Case 3
                    If Ntype = 1 Then
                        a1$ = "剪断τ "
                    Else
                        a1$ = "曲げＭ "
                    End If
                Case 4
                    a1$ = "曲げσb "
                Case 5
                    a1$ = "合計σA "
                Case 6
                    a1$ = "剪断τ "
            End Select

            For k = 1 To 2
                Select Case k
                    Case 1
                        aa$ = a1$ + "max,  "
                        aa$ = aa$ + Space$(12 - Len(aa$)) + Str$(Zfmax(i)) + ",  "
                        aa$ = aa$ + Space$(32 - Len(aa$)) + Str$(KEfmax(i)) + ",  "
                        aa$ = aa$ + Space$(44 - Len(aa$)) + Str$(KPfmax(i)) + ",  "
                        aa$ = aa$ + Space$(56 - Len(aa$)) + Str$(Tfmax(i))
                        SwK.WriteLine(aa$)
                        If i = 0 Or i > k1 Then
                            CalcRes$ = CalcRes$ + Cr$ + aa$
                        End If
                    Case 2
                        If i < imax Then
                            aa$ = a1$ + "min,  "
                            aa$ = aa$ + Space$(12 - Len(aa$)) + Str$(Zfmin(i)) + ",  "
                            aa$ = aa$ + Space$(32 - Len(aa$)) + Str$(KEfmin(i)) + ",  "
                            aa$ = aa$ + Space$(44 - Len(aa$)) + Str$(KPfmin(i)) + ",  "
                            aa$ = aa$ + Space$(56 - Len(aa$)) + Str$(Tfmin(i))
                            SwK.WriteLine(aa$)
                            If i = 0 Or i > k1 Then
                                CalcRes$ = CalcRes$ + Cr$ + aa$
                            End If
                        End If
                End Select
            Next k
        Next i

    End Sub

    Private Sub RestCond(ByVal k As Integer, ByVal mb As Integer, _
        ByVal nx As Integer, ByVal ub As Single)
        '拘束条件処理
        'k･･･変数番号
        'mb･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        'ub･･･拘束値
        Dim it, j, k1, ka, mx As Integer
        If k > 1 Then
            ka = k - mb + 1
            If ka < 1 Then
                ka = 1
            End If
            For it = ka To k - 1
                j = k - it
                k1 = Idiag(k) - j
                If k1 > Idiag(k - 1) Then
                    If ub <> 0 Then
                        TfD(it) = TfD(it) - Tk(k1) * ub
                    End If
                    Tk(k1) = 0
                End If
            Next it
        End If
        If k < nx Then
            mx = mb
            If k + mb - 1 > nx Then
                mx = nx - k + 1
            End If
            For j = 2 To mx
                k1 = Idiag(k + j - 1) - j + 1
                If k1 > Idiag(k + j - 2) Then
                    If ub <> 0 Then
                        it = k + j - 1
                        TfD(it) = TfD(it) - Tk(k1) * ub
                    End If
                    Tk(k1) = 0
                End If
            Next j
        End If
        Tk(Idiag(k)) = 1
        TfD(k) = ub

    End Sub

    Private Sub RoundPrep2(ByRef kind As Integer, ByRef nb As Integer, ByVal zb As Single)
        '丸め準備2（数値の最下位を基準）
        'kind･･･丸め区分（0:1以上、1:1未満）
        'nb･･･丸め位置の桁数
        'zb･･･丸め基準値
        Dim a1$, aa$
        Dim k1, k2 As Integer

        aa$ = LTrim(Str(zb))
        k1 = Len(aa$)
        k2 = InStr(aa$, ".")
        If k2 > 0 Then
            kind = 1
            nb = k1 - k2
        Else
            kind = 0
            nb = 0
            Do
                nb = nb + 1
                a1$ = aa.Substring(k1 - nb, 1)
                If a1$ <> "0" Then
                    Exit Do
                End If
            Loop
        End If

    End Sub

    Private Sub ShellSort2(ByVal kind As Integer, ByRef kcbuf() As Integer, _
    ByVal xbuf() As Single, ByVal ybuf() As Single)
        'ｼｪﾙｿｰﾄ
        'kind･･･主ｿｰﾄの座標軸番号（1:X軸、2:Y軸）
        'kcbuf()･･･元の節点の変数順序
        'xbuf(),ybuf()･･･節点の座標
        Dim i As Integer
        Dim nsort(Npoint) As Integer
        Dim work(Npoint) As Single

        Select Case kind
            Case 1
                For i = 1 To Npoint
                    nsort(i) = i
                    work(i) = xbuf(i)
                Next i
            Case 2
                For i = 1 To Npoint
                    nsort(i) = i
                    work(i) = ybuf(i)
                Next i
        End Select

        Call ShellSortStd(Npoint, nsort, work)    'ｼｪｯﾙｿｰﾄ基本

        Call MiniSort2(kind, nsort, work, xbuf, ybuf)    'ﾐﾆｿｰﾄ

        For i = 1 To Npoint
            kcbuf(nsort(i)) = i
        Next i

    End Sub

    Private Sub ShellSortStd(ByVal nx As Integer, ByRef nsort() As Integer, ByRef work() As Single)
        'ｼｪﾙｿｰﾄ基本
        'nx･･･変数の数
        'nsort()･･ｿｰﾄ順の元変数の番号
        'work()･･･ｿｰﾄ順の変数値
        Dim i, ib, j, m As Integer
        Dim varb As Single

        m = nx
        Do While m > 1
            m = m \ 2
            For j = m + 1 To nx
                varb = work(j)
                ib = nsort(j)
                i = j - m
                Do While work(i) >= varb
                    work(i + m) = work(i)
                    nsort(i + m) = nsort(i)
                    i = i - m
                    If i <= 0 Then
                        Exit Do
                    End If
                Loop
                work(i + m) = varb
                nsort(i + m) = ib
            Next j
        Loop

    End Sub

    Private Sub Solver1(ByVal nx As Integer)
        'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ1（LDL分解）
        'nx･･･変数の数
        Dim aa$, timn$
        Dim i, i0, icount, ii, ij, ik, jk, j, j0, jj, jm1, k, kk, mi, mij, mj As Integer
        Dim sum As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ1 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Application.DoEvents()
        icount = 0
        For i = 2 To nx
            i0 = Idiag(i) - i
            mi = Idiag(i - 1) - i0 + 1
            For j = mi To i
                sum = 0
                j0 = Idiag(j) - j
                mj = 1
                If j > 1 Then
                    mj = Idiag(j - 1) - j0 + 1
                End If
                mij = mi
                If mj > mi Then
                    mij = mj
                End If
                ij = i0 + j
                jm1 = j - 1
                For k = mij To jm1
                    If mij <= jm1 Then
                        ik = i0 + k
                        kk = Idiag(k)
                        jk = j0 + k
                        sum = sum + Tk(ik) * Tk(kk) * Tk(jk)
                    End If
                Next k
                If j = i Then
                    ii = i0 + i
                    Tk(ii) = Tk(ii) - sum
                Else
                    jj = Idiag(j)
                    Tk(ij) = (Tk(ij) - sum) / Tk(jj)
                End If
            Next j
            If icount < 999 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next i

        gr.Dispose()

    End Sub

    Private Sub Solver2(ByVal mh As Integer, ByVal nx As Integer)
        'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ2（前進・後退処理）
        'mh･･･ﾊｰﾌﾊﾞﾝﾄﾞ幅
        'nx･･･変数の数
        Dim aa$, timn$
        Dim i, i0, i1, j, j0, j1, j2, j3, k As Integer
        Dim sum As Double
        Dim gr As Graphics = PictureBox2.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        timn$ = ""
        aa$ = "ｿﾙﾊﾞｰ2 計算中   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Application.DoEvents()
        For i = 2 To nx
            sum = 0
            i0 = Idiag(i) - i
            j1 = Idiag(i - 1) - i0 + 1
            j2 = i - 1
            If j1 <> i Then
                For j = j1 To j2
                    j0 = i0 + j
                    sum = sum + Tk(j0) * TfD(j)
                Next j
            End If
            TfD(i) = TfD(i) - sum
        Next i
        For i = 1 To nx
            i1 = Idiag(i)
            If Tk(i1) <= 0 Then
                aa$ = "ｿﾙﾊﾞｰ2でﾋﾟﾎﾞｯﾄが0以下になりました！"
                MsgBox(aa$, 0, "計算エラー")
                End
            End If
            TfD(i) = TfD(i) / Tk(i1)
        Next i

        For k = nx - 1 To 1 Step -1
            j1 = k + 1
            j2 = j1 + mh - 1
            If j2 > nx Then
                j2 = nx
            End If
            sum = 0
            For j = j1 To j2
                j3 = Idiag(j - 1) - Idiag(j) + j + 1
                If j3 <= k Then
                    j0 = Idiag(j) - j + k
                    sum = sum + Tk(j0) * TfD(j)
                End If
            Next j
            TfD(k) = TfD(k) - sum
        Next k

        gr.Dispose()

    End Sub

    Private Sub SpringSet()
        'バネ支持の設定
        Dim ib, j, jj, k, k1, k2, kb, kk, m As Integer
        Dim b1 As Single
        Dim acos(2), aval1(2), aval2(2), csb(2), fsb(2) As Single
        For ib = 1 To Nspring
            If KPspring(ib, 2) = 0 Then '単独ﾊﾞﾈ
                k = Ndim * (Kcomp(KPspring(ib, 1)) - 1)
                For j = 1 To 2
                    k = k + 1
                    kk = Idiag(k)
                    Tk(kk) = Tk(kk) - Cspring(ib, j)
                    TfD(k) = TfD(k) + Fspring(ib, j)
                Next j
            Else  '節点間ﾊﾞﾈ
                k1 = KPspring(ib, 1)
                k2 = KPspring(ib, 2)
                aval1(1) = X(k1)
                aval1(2) = Y(k1)
                aval2(1) = X(k2)
                aval2(2) = Y(k2)
                Call CosCalc2(aval1, aval2, acos) '2点間の方向余弦の計算
                For j = 1 To 2
                    csb(j) = Cspring(ib, 1) * acos(j)
                    fsb(j) = Fspring(ib, 1) * acos(j)
                Next j
                If Ntype < 3 Then
                    k1 = Ndim * (Kcomp(k1) - 1)
                    k2 = Ndim * (Kcomp(k2) - 1)
                Else
                    k1 = Lr(k1) - 1
                    k2 = Lr(k2) - 1
                End If
                For m = 1 To 2  '節点1と2
                    If m = 1 Then
                        k = k1
                        b1 = 1  '右辺への初期ﾊﾞﾈ力の加算符号
                    Else
                        k = k2
                        b1 = -1
                    End If
                    For j = 1 To 2  'XとY方向
                        k = k + 1
                        kk = Idiag(k)
                        Tk(kk) = Tk(kk) - csb(j) * acos(j)
                        TfD(k) = TfD(k) + b1 * fsb(j)
                        If j = 1 Then   'X変位の場合はY変位への剛性加算
                            kk = Idiag(k + 1) - 1
                            Tk(kk) = Tk(kk) - csb(1) * acos(2)
                        End If
                        If m = 1 And k1 < k2 Then   '大きい変数番号の側で記憶
                            For jj = 1 To 2
                                kb = k2 + jj
                                kk = Idiag(kb) - kb + k
                                Tk(kk) = Tk(kk) + csb(j) * acos(jj)
                            Next jj
                        ElseIf m = 2 And k2 < k1 Then
                            For jj = 1 To 2
                                kb = k1 + jj
                                kk = Idiag(kb) - kb + k
                                Tk(kk) = Tk(kk) + csb(j) * acos(jj)
                            Next jj
                        End If
                    Next j
                Next m
            End If
        Next ib
    End Sub

    Private Sub Store()
        '全体ﾏﾄﾘｯｸｽへの蓄積
        Dim i, it, itb, j, jt, jtb, k As Integer
        For i = 1 To Nvar
            it = NPrefer(i)
            If it > 0 Then
                For j = i To Nvar
                    jt = NPrefer(j)
                    If jt > 0 Then
                        If it <= jt Then
                            itb = it
                            jtb = jt
                        Else
                            itb = jt
                            jtb = it
                        End If
                        k = Idiag0(jtb) - jtb + itb
                        Tk(k) = Tk(k) + Ek(i, j)
                    End If
                Next j
            End If
        Next i

    End Sub

    Private Sub StoreS()
        '全体ﾏﾄﾘｯｸｽへの蓄積
        Dim i, it, itb, j, jt, jtb, k As Integer
        For i = 1 To Nvar
            it = NPrefer(i)
            If it > 0 Then
                For j = i To Nvar
                    jt = NPrefer(j)
                    If jt > 0 Then
                        If it <= jt Then
                            itb = it
                            jtb = jt
                        Else
                            itb = jt
                            jtb = it
                        End If
                        k = Idiag(jtb) - jtb + itb
                        Tk(k) = Tk(k) + Ek(i, j)
                        RMmatb(k) = RMmatb(k) + Em(i, j)
                    End If
                Next j
            End If
        Next i

    End Sub

    Private Sub TfVecClear(ByVal nx As Integer)
        'Tfﾍﾞｸﾄﾙのｸﾘｱ
        'nx･･･次数
        Dim i As Integer
        For i = 1 To nx
            TfD(i) = 0
        Next i

    End Sub

    Private Sub TimConv(ByRef tima$, ByVal rsec As Single)
        '秒数から時分秒への換算
        'tima$･･･時分秒表示の時間
        'rsec･･･秒単位の時間
        Dim rhour, rmin As Single
        rhour = Int(rsec / 3600)
        rsec = rsec - rhour * 3600
        rmin = Int(rsec / 60)
        rsec = CInt(rsec + 1 - rmin * 60)
        tima$ = Str$(rhour) + "h" + Str$(rmin) + "min" + Str$(rsec) + "s"

    End Sub

    Private Function TimeLap(ByVal date1 As Date, ByVal date2 As Date) As Single
        '経過時間の計算（1日以内）
        'date1･･･開始時刻
        'date2･･･終了時刻
        Dim sec1, sec2 As Single
        If date1.Date <> date2.Date Then
            sec2 = 3600 * 24
        End If
        sec1 = 3600 * date1.Hour + 60 * date1.Minute + date1.Second
        sec1 = sec1 + 0.001 * date1.Millisecond
        sec2 = sec2 + 3600 * date2.Hour + 60 * date2.Minute + date2.Second
        sec2 = sec2 + 0.001 * date2.Millisecond
        TimeLap = sec2 - sec1

    End Function

    Private Sub TransMatrix(ByVal cs As Single, ByVal cc As Single)
        '座標変換行列の設定
        'cc･･･部材のcosφ
        'cs･･･部材のsinφ
        Dim ii As Integer
        Trans(1, 1) = cc : Trans(1, 2) = cs
        Trans(2, 1) = -cs : Trans(2, 2) = cc
        If Ntype = 1 Then
            ii = 3
        Else
            ii = 4
            Trans(3, 3) = 1
            Trans(6, 6) = 1
        End If
        Trans(ii, ii) = cc : Trans(ii, ii + 1) = cs
        Trans(ii + 1, ii) = -cs : Trans(ii + 1, ii + 1) = cc
    End Sub

    Private Sub TKmatSet()
        'TK行列設定
        Dim i, ii As Integer
        Dim b1, b2 As Single

        For i = 1 To NumEff
            Tk(i) = 0
        Next i
        b1 = 0.5 * DTime
        b2 = Beta * DTime * DTime
        For i = 1 To NumEff
            Tk(i) = RMmatb(i) + b2 * RKmatb(i)
            If KindVEqua = 1 Then
                If KindDamp = 0 Or Ndamp > 0 Then
                    Tk(i) = Tk(i) + b1 * Cmatb(i)
                End If
            End If
        Next i
        If KindVEqua = 1 Then
            If KindDamp = 1 And Ndamp = 0 Then
                For i = 1 To Norder
                    ii = Idiag(i)
                    Tk(ii) = Tk(ii) + b1 * Cmatb(ii)
                Next i

            End If
        End If

    End Sub

    Private Sub WeightLoad()
        '自重荷重の加算
        '軸力等は初期内力として処理
        Dim i, ie, ii, k, kb, kp As Integer
        Dim area, b1, b2, b3, cc, cs, fnorm, ftang As Single
        Dim rlen, rmoment, ud As Single
        kb = 0
        For ie = 1 To Nelem
            kp = NumMat(ie)
            If kp <> kb Then
                kb = kp
                ud = DataMat(kp, 2)
                area = DataMat(kp, 3)
            End If
            If ud > 0 Then
                For ii = 1 To 2
                    i = NNelem(ie, ii)
                    XE(ii) = X(i)
                    YE(ii) = Y(i)
                Next ii
                b1 = XE(2) - XE(1)
                b2 = YE(2) - YE(1)
                rlen = Math.Sqrt(b1 * b1 + b2 * b2)
                cs = b2 / rlen
                cc = b1 / rlen

                b3 = ud * area
                fnorm = -0.5 * b3 * cc * rlen
                ftang = -0.5 * b3 * cs * rlen
                rmoment = fnorm * rlen / 6

                For ii = 1 To 2
                    i = NNelem(ie, ii)
                    'k = Ndim * (i - 1)
                    k = Ndim * (Kcomp(i) - 1)
                    TfD(k + 1) = TfD(k + 1) - fnorm * cs + ftang * cc
                    TfD(k + 2) = TfD(k + 2) + fnorm * cc + ftang * cs
                    If Ntype = 2 Then
                        If ii = 1 Then
                            b1 = rmoment
                        Else
                            b1 = -rmoment
                        End If
                        TfD(k + 3) = TfD(k + 3) + b1
                    End If
                    If ii = 1 Then
                        b1 = ftang
                        b2 = -fnorm
                    Else
                        b1 = -ftang
                        b2 = fnorm
                    End If
                    BarForce(ie, ii) = BarForce(ie, ii) + b1
                    BarShear(ie, ii) = BarShear(ie, ii) + b2
                    If Ntype = 2 Then
                        BarMoment(ie, ii) = BarMoment(ie, ii) + rmoment
                    End If
                Next ii
            End If
        Next ie
    End Sub

    Private Sub WeightLoad2()
        '自重荷重の加算2
        '軸力等は初期内力として処理
        Dim i, ie, ii, k, kb, kp As Integer
        Dim area, b1, b2, b3, cc, cs, ftang, rlen, rmoment, ud As Double
        Dim fnorm(2) As Double

        kb = 0
        For ie = 1 To Nelem
            kp = NumMat(ie)
            If kp <> kb Then
                kb = kp
                ud = DataMat(kp, 2)
                area = DataMat(kp, 3)
            End If
            If ud > 0 Then
                For ii = 1 To 2
                    i = NNelem(ie, ii)
                    XE(ii) = X(i)
                    YE(ii) = Y(i)
                Next ii
                b1 = XE(2) - XE(1)
                b2 = YE(2) - YE(1)
                rlen = Math.Sqrt(b1 * b1 + b2 * b2)
                cs = b2 / rlen
                cc = b1 / rlen

                b3 = ud * area
                Select Case KindElem(ie)
                    Case 3
                        fnorm(1) = -3 * b3 * cc * rlen / 8
                        fnorm(2) = -5 * b3 * cc * rlen / 8
                        rmoment = -b3 * rlen * rlen / 8
                    Case 4
                        fnorm(1) = -5 * b3 * cc * rlen / 8
                        fnorm(2) = -3 * b3 * cc * rlen / 8
                        rmoment = -b3 * rlen * rlen / 8
                    Case Else
                        fnorm(1) = -0.5 * b3 * cc * rlen
                        fnorm(2) = fnorm(1)
                        rmoment = fnorm(1) * rlen / 6
                End Select
                ftang = -0.5 * b3 * cs * rlen

                For ii = 1 To 2
                    i = NNelem(ie, ii)
                    k = Lr(i) - 1
                    TfD(k + 1) = TfD(k + 1) - fnorm(ii) * cs + ftang * cc
                    TfD(k + 2) = TfD(k + 2) + fnorm(ii) * cc + ftang * cs
                    If KindElem(ie) = 2 Or KindElem(ie) = 4 Then
                        If ii = 1 Then
                            TfD(k + 3) = TfD(k + 3) + rmoment
                        End If
                    End If
                    If KindElem(ie) = 2 Or KindElem(ie) = 3 Then
                        If ii = 2 Then
                            TfD(k + 3) = TfD(k + 3) - rmoment
                        End If
                    End If
                    If ii = 1 Then
                        b1 = ftang
                        b2 = -fnorm(1)
                    Else
                        b1 = -ftang
                        b2 = fnorm(2)
                    End If
                    BarForce(ie, ii) = BarForce(ie, ii) + b1
                    BarShear(ie, ii) = BarShear(ie, ii) + b2
                    If KindElem(ie) = 2 Or KindElem(ie) = 4 Then
                        If ii = 1 Then
                            BarMoment(ie, 1) = BarMoment(ie, 1) + rmoment
                        End If
                    End If
                    If KindElem(ie) = 2 Or KindElem(ie) = 3 Then
                        If ii = 2 Then
                            BarMoment(ie, 2) = BarMoment(ie, 2) + rmoment
                        End If
                    End If
                Next ii
            End If
        Next ie

    End Sub

    Private Sub BarsVRCal3_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim aa$, timn$
        Dim i, ib, iconv, icount, id, ie, ik, iLtime, istage, istep, j, jb As Integer
        Dim k, kb, kh, mb, na, nb, nx As Integer
        Dim area, b1, dteps, ej, ri, rmesh, rmeshmax, rou, sec, ub As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        Me.Show()

        Crate = 0.001
        timn$ = ""
        Call TimCal(0, timn$)   'ﾀｲﾏｰ計算（時間ｸﾘｱ）
        aa$ = "計算開始" + "   " + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Label1.Text = "計算実施中！"
        Label2.Text = "しばらくお待ちください。"
        Label3.Text = ""

        Dim xbuf(Npoint), ybuf(Npoint) As Single
        Call AxisValueTreat(xbuf, ybuf)   '座標値の端数処理
        Call PnumImproveNew(mb, xbuf, ybuf)  '節点順序の改良
        Application.DoEvents()

        Call InitBase()         '初期ﾍﾞｰｽ設定
        Mband = mb

        aa$ = "初期設定  "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        Call InitialSet2S(mb)  '初期設定2

        If KindSLoad > 0 Then
            Call InitialSet1S()  '初期設定
            If Ntype < 3 Then
                Call WeightLoad()   '自重荷重の加算
            Else
                Call WeightLoad2()   '自重荷重の加算2
            End If
        End If

        aa$ = "解析要素計算  "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        istage = 0
        kb = 0
        Application.DoEvents()
        icount = 0
        For ie = 1 To Nelem
            '要素ﾏﾄﾘｯｸｽの計算
            Call ElemMatrix(ie, istage, kb, ej, rou, area, ri)
            Call StoreS()       '全体ﾏﾄﾘｯｸｽへの蓄積（静解析用）
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        If Nspring > 0 Then
            Call SpringSet()    'ﾊﾞﾈ支持の設定
        End If

        For i = 1 To NumEff
            RKmatb(i) = Tk(i)
        Next i

        If KindSLoad > 0 Then
            For ib = 1 To Nbound
                If Ntype < 3 Then
                    j = Ndim * (Kcomp(Nrest(ib)) - 1)
                    If Ntype = 1 Then
                        nb = 2
                    Else
                        nb = 3
                    End If
                Else
                    k = Nrest(ib)
                    j = Lr(k) - 1
                    nb = NvarP(Kcomp(k))
                End If
                For id = 1 To nb
                    If Jdirect(ib, id) > 0 Then
                        ub = Vdirect(ib, id)
                        k = j + id
                        Fdirect(ib, id) = TfD(k)
                        Call RestCond(k, mb, Nall, ub)    '拘束条件処理
                    End If
                Next id
            Next ib

            Call Solver1(Nall)  'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ1（LDL分解）

            Call Solver2(mb, Nall)  'ｽｶｲﾗｲﾝ法のｿﾙﾊﾞｰ2（前進・後退処理）

            '節点変位の保存（元の節点順）
            For i = 1 To Npoint
                If Ntype < 3 Then
                    jb = Ndim * (i - 1)
                    j = Ndim * (Kcomp(i) - 1)
                    nb = Ndim
                Else
                    jb = LrD(i) - 1
                    j = Lr(i) - 1
                    nb = NvarPD(i)
                End If
                For id = 1 To nb
                    kb = jb + id
                    k = j + id
                    TfS(kb) = TfD(k)
                Next id
            Next i
        Else
            If Kboundfree = 0 Then
                '固定節点変位の保存（元の節点順）
                For ib = 1 To Nbound
                    If Ntype < 3 Then
                        j = Ndim * (Nrest(ib) - 1)
                        nb = Ndim
                    Else
                        j = LrD(ib) - 1
                        nb = NvarPD(ib)
                    End If
                    For id = 1 To nb
                        If Jdirect(ib, id) > 0 Then
                            ub = Vdirect(ib, id)
                            k = j + id
                            TfS(k) = ub
                        End If
                    Next id
                Next ib
            End If
        End If

        Application.DoEvents()
        aa$ = "動解析初期設定  "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        If Kboundfree = 0 Then
            '拘束条件処理
            For ib = 1 To Nbound
                If Ntype < 3 Then
                    j = Ndim * (Nrest(ib) - 1)
                    nb = Ndim
                Else
                    j = LrD(Nrest(ib)) - 1
                    nb = NvarPD(Nrest(ib))
                End If
                For id = 1 To nb
                    If Jdirect(ib, id) > 0 Then
                        k = j + id
                        Nodemb(k) = 0
                    End If
                Next id
            Next ib
        End If

        Call MatrixReduct()    '行列の縮減

        Call MmatSet()          'Ｍ行列の設定

        If KindVEqua > 0 Then
            Call CmatSet()      'Ｃ行列の設定
        End If

        Call MatMaxCalc()       '行列要素の最大値計算  

        Call ResFile1U()         '結果ﾌｧｲﾙへの出力1

        ReDim FLoadVib(NPvib, 3), FLoadVibI(NPvib, 3), FLoadVibX(NPvib, 3)
        Beta = 0.25
        nx = Norder
        ReDim Accel1(nx), Accel2(nx), Disp1(nx), Disp2(nx), Vel1(nx), Vel2(nx)

        Application.DoEvents()
        aa$ = "動解析開始  "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        iconv = 0
        KVibOff = 0
        If KindLvib = 1 Then
            Call AccelPointSet()     '加速度加振点の設定
        End If
        If KAnal = 0 Then
            dteps = 0.01 * DTime
            TimeNew = 0
            istep = 0
            iLtime = 0
            kh = 0
            Do
                Dim date1 As Date = Now
                Call TfVecClear(nx)     'Tfﾍﾞｸﾄﾙのｸﾘｱ
                If istep = 0 Then
                    Call LoadVibNew(kh, iLtime)   '振動外力区間の新規設定
                End If
                kb = istep Mod NstepF
                If kb = 0 And kh = 0 Then
                    For i = 1 To NPvib
                        If Ntype < 3 Then
                            na = Ndim
                        Else
                            ib = KPvib(i)
                            na = NvarPD(ib)
                        End If
                        For j = 1 To na
                            FLoadVibI(i, j) = FLoadVib(i, j)
                        Next j
                    Next i
                    Call LoadVibNew(kh, iLtime)   '振動外力区間の新規設定
                End If
                If istep = 0 Then
                    If KindLvib = 0 Then
                        Call AccelInit(mb)    '初期加速度の計算
                    End If
                End If
                If kh > -2 Then
                    Call LoadVibSet(kh, KindLvib, istep, NstepF) '振動外力の設定
                End If

                If istep > 0 Then
                    Call AccelCalc(mb)    '加速度の計算
                    Call DispCalc()     '変位の計算
                End If

                kb = istep Mod Nstep
                If istep = 0 Or kb = 0 Then
                    Call RoundTreat(KindTime, NbTime, TimeNew)  '丸め処理
                    Call ResFile2U(kh, istep) '結果ﾌｧｲﾙへの出力2
                    Call ForceCalc(istep)   '軸力等の計算
                    Call ForceCalc2(istep, mb) '全節点の力等計算
                    kb = -1
                End If
                If TimeNew >= TimeMax Then
                    If kb >= 0 Then
                        Call RoundTreat(KindTime, NbTime, TimeNew)  '丸め処理
                        Call ResFile2U(kh, istep) '結果ﾌｧｲﾙへの出力2
                        Call ForceCalc(istep)   '軸力等の計算
                        Call ForceCalc2(istep, mb) '全節点の力等計算
                    End If
                    Exit Do
                Else
                    '進行表示
                    aa$ = "ｽﾃｯﾌﾟ" + Str$(istep) + " 終了  "
                    Call TimCal(1, timn$)
                    aa$ = aa$ + timn$
                    gr.Clear(Color.White)
                    gr.DrawString(aa$, fnt, myBrush, 1, 1)
                    ProgressBar1.Value = 100 * TimeNew / TimeMax
                    If istep > 1 Then
                        rmesh = TimeMax / DTime - istep
                        Dim date2 As Date = Now
                        sec = TimeLap(date1, date2)
                        Call ReqTime(1.0, rmesh, sec)   '残りの所要時間の計算
                    End If

                    istep = istep + 1
                    TimeNew = istep * DTime
                    If TimeNew + dteps > TimeMax Then
                        TimeNew = TimeMax
                    End If
                    Call NewStep(nx) '新ｽﾃｯﾌﾟ準備
                End If
                Application.DoEvents()
            Loop
        Else
            DTime = 1 / FreqLVib / NdivCyc
            ReDim Accel0(nx), Disp0(nx), Vel0(nx)
            rmesh = (NKmax + 1) * NdivCyc
            rmeshmax = rmesh
            Call TfVecClear(nx)     'Tfﾍﾞｸﾄﾙのｸﾘｱ
            Call LoadVibSet2(KindLvib, 0)  '振動外力の設定2
            If KindLvib = 0 Then
                Call AccelInit(mb)    '初期加速度の計算
            End If
            For i = 1 To nx
                Accel1(i) = Accel2(i)
                Disp1(i) = Disp2(i)
                Vel1(i) = Vel2(i)
                Accel0(i) = Accel2(i)
                Disp0(i) = Disp2(i)
                Vel0(i) = Vel2(i)
            Next i
            For ik = 1 To NKmax + 1
                DeltaMax = 0
                For istep = 1 To NdivCyc
                    Dim date1 As Date = Now
                    Call TfVecClear(nx)     'Tfﾍﾞｸﾄﾙのｸﾘｱ
                    Call LoadVibSet2(KindLvib, istep) '振動外力の設定2
                    Call AccelCalc(mb)    '加速度の計算

                    Call DispCalc()     '変位の計算
                    Call DispCheck()    '変位のﾁｪｯｸ

                    If iconv > 0 Then
                        Call ResFile2U(0, istep) '結果ﾌｧｲﾙへの出力2
                        Call ForceCalc(istep)   '軸力等の計算
                        Call ForceCalc2(istep, mb) '全節点の力等計算
                    End If
                    If istep = NdivCyc Then
                        If ik > 1 Or iconv > 0 Then
                            If iconv > 0 Then
                                Call ConvResultU(iconv, ik) '収束結果の出力
                                iconv = 2
                            Else
                                b1 = Math.Abs(DeltaMax - DeltaMaxb)
                                If DeltaMax = 0 And b1 = 0 Then
                                    iconv = 3
                                    Exit For
                                End If
                                If b1 < DeltaMax * EpsCalc Then
                                    Call ConvResultU(iconv, ik) '収束結果の出力
                                    Call InitAdjust(nx) '初期値調整
                                    TimeNew = 0
                                    Call ResFile2U(0, 0) '結果ﾌｧｲﾙへの出力2
                                    Call ForceCalc(0)   '軸力等の計算
                                    Call ForceCalc2(0, mb) '全節点の力等計算
                                    iconv = 1
                                    rmesh = NdivCyc + 1
                                    rmeshmax = rmesh
                                End If
                            End If
                        End If
                        DeltaMaxb = DeltaMax
                        If iconv = 0 Then
                            Call InitAdjust(nx) '初期値調整
                        End If
                    End If
                    '進行表示
                    aa$ = "ik=" + Str$(ik) + " istep=" + Str(istep) + " 終了  "
                    Call TimCal(1, timn$)
                    aa$ = aa$ + timn$
                    gr.Clear(Color.White)
                    gr.DrawString(aa$, fnt, myBrush, 1, 1)
                    rmesh = rmesh - 1
                    ProgressBar1.Value = 100 * (rmeshmax - rmesh) / rmeshmax
                    Dim date2 As Date = Now
                    sec = TimeLap(date1, date2)
                    Call ReqTime(1.0, rmesh, sec)   '残りの所要時間の計算
                    If iconv = 1 Then
                        TimeNew = TimeNew + DTime
                    End If
                    Call NewStep(nx) '新ｽﾃｯﾌﾟ準備
                    Application.DoEvents()
                Next istep
                If iconv > 1 Then
                    Exit For
                End If
            Next ik
        End If

        aa$ = "ｽﾃｯﾌﾟ計算終了   "
        Call TimCal(1, timn$)
        aa$ = aa$ + timn$
        gr.Clear(Color.White)
        gr.DrawString(aa$, fnt, myBrush, 1, 1)

        If iconv < 3 Then
            Call ResFile3U(iconv)     '結果ﾌｧｲﾙへの出力3
        End If

        '進行表示
        ProgressBar1.Value = 100

        Call TimCal(1, timn$)
        aa$ = "END   " & timn$
        SwK.WriteLine(aa$)
        SwK.Close()

        Label1.Text = "計算終了！"
        If KAnal = 0 Or iconv = 2 Then
            Label2.Text = "計算結果をファイルへ出力しました。"
            aa$ = "計算が終了しました。"
            aa$ = aa$ + Cr$ + CalcRes$
        Else
            Label2.Text = "計算結果は出力されませんでした。"
            Select Case iconv
                Case 0
                    aa$ = "収束しませんでした！"
                Case 1
                    aa$ = "収束しましたが、計算回数不足です！"
                Case 3
                    aa$ = "変位が0のままです！"
            End Select
        End If
        Label3.Text = "計算終了   " + timn$
        Me.BringToFront()
        If KindBatch = 0 Then
            MsgBox(aa$, 0, "計算確認")
        Else
            Kfinish = 1
        End If
        gr.Dispose()

        Me.Close()

    End Sub

End Class
