'ﾏﾄﾘｯｸｽﾃﾞｰﾀ計算の実行ﾌﾟﾛｸﾞﾗﾑ
Imports System.Drawing

Public Class BarsVRCal3a
    Inherits System.Windows.Forms.Form

#Region " Windows フォーム デザイナで生成されたコード "

    Public Sub New()
        MyBase.New()

        ' この呼び出しは Windows フォーム デザイナで必要です。
        InitializeComponent()

        ' InitializeComponent() 呼び出しの後に初期化を追加します。

    End Sub

    ' Form は dispose をオーバーライドしてコンポーネント一覧を消去します。
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows フォーム デザイナで必要です。
    Private components As System.ComponentModel.IContainer

    ' メモ : 以下のプロシージャは、Windows フォーム デザイナで必要です。
    ' Windows フォーム デザイナを使って変更してください。  
    ' コード エディタは使用しないでください。
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents ProgressBar1 As System.Windows.Forms.ProgressBar
    Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.Label3 = New System.Windows.Forms.Label()
        Me.ProgressBar1 = New System.Windows.Forms.ProgressBar()
        Me.PictureBox1 = New System.Windows.Forms.PictureBox()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Label1.Location = New System.Drawing.Point(128, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(184, 24)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "マトリックスデータ計算の実行"
        Me.Label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(24, 56)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(256, 16)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "Label2"
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(40, 96)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(280, 16)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Label3"
        '
        'ProgressBar1
        '
        Me.ProgressBar1.Location = New System.Drawing.Point(48, 232)
        Me.ProgressBar1.Name = "ProgressBar1"
        Me.ProgressBar1.Size = New System.Drawing.Size(336, 24)
        Me.ProgressBar1.TabIndex = 5
        '
        'PictureBox1
        '
        Me.PictureBox1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureBox1.Location = New System.Drawing.Point(128, 168)
        Me.PictureBox1.Name = "PictureBox1"
        Me.PictureBox1.Size = New System.Drawing.Size(144, 24)
        Me.PictureBox1.TabIndex = 6
        Me.PictureBox1.TabStop = False
        '
        'BarsVRCal3a
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.BackColor = System.Drawing.SystemColors.ControlLightLight
        Me.ClientSize = New System.Drawing.Size(432, 278)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.PictureBox1, Me.ProgressBar1, Me.Label3, Me.Label2, Me.Label1})
        Me.Name = "BarsVRCal3a"
        Me.Text = "BarsVRCal3a"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Dim Fw1, Fw2 As Single      '進行表示の水平枠位置
    Dim Crate As Single         '混合要素におけるﾗｰﾒﾝ要素追加微小比

    Dim Em(,), Emb(,) As Single '要素の質量ﾏﾄﾘｯｸｽ計算の配列
    Dim RMmatb() As Single      '全変位方向の質量ﾏﾄﾘｯｸｽ
    Dim Trans(,) As Single      '座標変換ﾏﾄﾘｯｸｽ

    Private Sub CoeffMatrix(ByVal cmass As Single, ByVal rlen As Single)
        '各要素の係数ﾏﾄﾘｯｸｽの計算
        'cmass･･･要素質量
        'rlen･･･要素長さ
        Dim i, j, k As Integer
        Dim b1, b2, b3, b4, b5, b6, b7, b8, sm As Single
        b1 = cmass / 3
        b2 = cmass / 6
        Select Case Ntype
            Case 1
                For i = 1 To 4
                    Em(i, i) = b1
                Next i
                Em(1, 3) = b2 : Em(2, 4) = b2
                Em(3, 1) = b2 : Em(4, 2) = b2
            Case 2
                b3 = cmass * 13 / 35
                b4 = cmass * 9 / 70
                b5 = cmass * rlen * rlen / 105
                b6 = cmass * rlen * rlen / 140
                b7 = cmass * rlen * 11 / 210
                b8 = cmass * rlen * 13 / 420
                Em(1, 1) = b1 : Em(1, 4) = b2
                Em(2, 2) = b3 : Em(2, 3) = b7
                Em(2, 5) = b4 : Em(2, 6) = -b8
                Em(3, 2) = b7 : Em(3, 3) = b5
                Em(3, 5) = b8 : Em(3, 6) = -b6
                Em(4, 1) = b2 : Em(4, 4) = b1
                Em(5, 2) = b4 : Em(5, 3) = b8
                Em(5, 5) = b3 : Em(5, 6) = -b7
                Em(6, 2) = -b8 : Em(6, 3) = -b6
                Em(6, 5) = -b7 : Em(6, 6) = b5
        End Select

        If Ntype = 2 Then
            For i = 1 To Nvar
                For j = 1 To Nvar
                    sm = 0
                    For k = 1 To Nvar
                        sm = sm + Em(i, k) * Trans(k, j)
                    Next k
                    Emb(i, j) = sm
                Next j
            Next i
            For i = 1 To Nvar
                For j = 1 To Nvar
                    sm = 0
                    For k = 1 To Nvar
                        sm = sm + Trans(k, i) * Emb(k, j)
                    Next k
                    Em(i, j) = sm
                Next j
            Next i
        End If

    End Sub

    Private Sub CoeffMatrix2(ByVal kc As Integer, ByVal cmass As Single, ByVal rlen As Single)
        '各要素の係数ﾏﾄﾘｯｸｽの計算
        'kc･･･要素種類（1:ﾄﾗｽ、2:ﾗｰﾒﾝ、3:左端回転自由、4:右端回転自由）
        'cmass･･･要素質量
        'rlen･･･要素長さ
        Dim i, j, k As Integer
        Dim b1, b2, b3, b4, b5, b6, b7, b8, cb, sm As Single

        cb = 1.0 - Crate
        b1 = cmass / 3
        b2 = cmass / 6
        Em(1, 1) = b1 : Em(1, 4) = b2
        Em(4, 1) = b2 : Em(4, 4) = b1
        Select Case kc
            Case 1
                Em(2, 2) = b1 : Em(2, 5) = b2
                Em(5, 2) = b2 : Em(5, 5) = b1
            Case 2
                b3 = cmass * 13 / 35
                b4 = cmass * 9 / 70
                b5 = cmass * rlen * rlen / 105
                b6 = cmass * rlen * rlen / 140
                b7 = cmass * rlen * 11 / 210
                b8 = cmass * rlen * 13 / 420
                Em(2, 2) = b3 : Em(2, 3) = b7
                Em(2, 5) = b4 : Em(2, 6) = -b8
                Em(3, 2) = b7 : Em(3, 3) = b5
                Em(3, 5) = b8 : Em(3, 6) = -b6
                Em(5, 2) = b4 : Em(5, 3) = b8
                Em(5, 5) = b3 : Em(5, 6) = -b7
                Em(6, 2) = -b8 : Em(6, 3) = -b6
                Em(6, 5) = -b7 : Em(6, 6) = b5
            Case 3
                Em(2, 2) = cmass / 5
                Em(2, 5) = 2 * cmass / 15
                Em(2, 6) = -cmass * rlen / 20
                Em(5, 5) = 8 * cmass / 15
                Em(5, 6) = -7 * cmass * rlen / 60
                Em(6, 6) = cmass * rlen * rlen / 30
                Em(5, 2) = Em(2, 5)
                Em(6, 2) = Em(2, 6) : Em(6, 5) = Em(5, 6)
            Case 4
                Em(2, 2) = 8 * cmass / 15
                Em(2, 3) = 7 * cmass * rlen / 60
                Em(2, 5) = 2 * cmass / 15
                Em(3, 3) = cmass * rlen * rlen / 30
                Em(3, 5) = cmass * rlen / 20
                Em(5, 5) = cmass / 5
                Em(3, 2) = Em(2, 3)
                Em(5, 2) = Em(2, 5) : Em(5, 3) = Em(3, 5)
        End Select
        If kc > 2 Then
            b3 = cmass * 13 / 35
            b4 = cmass * 9 / 70
            b5 = cmass * rlen * rlen / 105
            b6 = cmass * rlen * rlen / 140
            b7 = cmass * rlen * 11 / 210
            b8 = cmass * rlen * 13 / 420
            Em(2, 2) = cb * Em(2, 2) + Crate * b3
            Em(2, 3) = cb * Em(2, 3) + Crate * b7
            Em(3, 2) = Em(2, 3)
            Em(2, 5) = cb * Em(2, 5) + Crate * b4
            Em(5, 2) = Em(2, 5)
            Em(2, 6) = cb * Em(2, 6) - Crate * b8
            Em(6, 2) = Em(2, 6)
            Em(3, 3) = cb * Em(3, 3) + Crate * b5
            Em(3, 5) = cb * Em(3, 5) + Crate * b8
            Em(5, 3) = Em(3, 5)
            Em(3, 6) = cb * Em(3, 6) - Crate * b6
            Em(6, 3) = Em(3, 6)
            Em(5, 5) = cb * Em(5, 5) + Crate * b3
            Em(5, 6) = cb * Em(5, 6) - Crate * b7
            Em(6, 5) = Em(5, 6)
            Em(6, 6) = cb * Em(6, 6) + Crate * b5
        End If

        If kc > 1 Then
            For i = 1 To Nvar
                For j = 1 To Nvar
                    sm = 0
                    For k = 1 To Nvar
                        sm = sm + Em(i, k) * Trans(k, j)
                    Next k
                    Emb(i, j) = sm
                Next j
            Next i
            For i = 1 To Nvar
                For j = 1 To Nvar
                    sm = 0
                    For k = 1 To Nvar
                        sm = sm + Trans(k, i) * Emb(k, j)
                    Next k
                    Em(i, j) = sm
                Next j
            Next i
        End If

    End Sub

    Private Sub ElemMatrix(ByVal ie As Integer, ByRef kb As Integer, _
        ByRef rou As Single, ByRef area As Single)
        '要素ﾏﾄﾘｯｸｽの計算
        'ie･･･要素番号
        'kb･･･材料番号
        'rou･･･材料の密度
        'area･･･断面積
        Dim i, id, ii, j, k, kc, kp, nb As Integer
        Dim b1, b2, cc, cmass, cs, rlen As Single
        kp = NumMat(ie)
        If kp <> kb Then
            kb = kp
            rou = RouMat(kp)
            area = DataMat(kp, 3)
        End If

        j = 0
        For ii = 1 To 2
            i = NNelem(ie, ii)
            XE(ii) = X(i)
            YE(ii) = Y(i)
            If Ntype < 3 Then
                k = Ndim * (i - 1)
                For id = 1 To Ndim
                    j = j + 1
                    k = k + 1
                    NPrefer(j) = k
                Next id
            Else
                k = LrD(i) - 1
                nb = NvarPD(i)
                For id = 1 To 3
                    j = j + 1
                    k = k + 1
                    NPrefer(j) = k
                    If id > nb Then
                        NPrefer(j) = 0
                    Else
                        NPrefer(j) = k
                    End If
                Next id
            End If
        Next ii

        b1 = XE(2) - XE(1)
        b2 = YE(2) - YE(1)
        rlen = Math.Sqrt(b1 * b1 + b2 * b2)
        cs = b2 / rlen
        cc = b1 / rlen
        cmass = rou * area * rlen

        For i = 1 To Nvar
            For j = 1 To Nvar
                Em(i, j) = 0
                Trans(i, j) = 0
            Next j
        Next i

        Call TransMatrix(cs, cc)   '座標変換行列の設定

        If Ntype < 3 Then
            Call CoeffMatrix(cmass, rlen)  '各要素の係数ﾏﾄﾘｯｸｽの計算
        Else
            kc = KindElem(ie)
            Call CoeffMatrix2(kc, cmass, rlen)    '各要素の係数ﾏﾄﾘｯｸｽの計算
        End If

    End Sub

    Private Sub InitialSet1()
        '初期設定
        Dim ib, ii, ip, j, nb As Integer
        If Ntype = 1 Then
            Nvar = 4
        Else
            Nvar = 6
        End If

        Nall = Ndim * Npoint
        ReDim Trans(Nvar, Nvar)
        ReDim Em(Nvar, Nvar), Emb(Nvar, Nvar)
        ReDim NPrefer(Nvar)
        ReDim Kdispmb(Nall), Nodemb(Nall)
        ReDim KdispMatR(Nall), NodeMatR(Nall)
        ReDim RMmatb(Nall), RMmatrix(Nall)

        If Ntype < 3 Then
            '行列の変数番号の対応設定
            For ip = 1 To Npoint
                ii = Ndim * (ip - 1)
                ib = 0
                For j = 1 To Ndim
                    ii = ii + 1
                    ib = ib + 1
                    Nodemb(ii) = ip
                    Kdispmb(ii) = ib
                Next j
            Next ip
        Else
            ReDim LrD(Npoint), NvarPD(Npoint)
            Call NvarPDSet()     '元ﾃﾞｰﾀ節点の変数の数を設定
            '行列の変数番号の対応設定
            ii = 0
            For ip = 1 To Npoint
                nb = NvarPD(ip)
                ib = 0
                LrD(ip) = ii + 1
                For j = 1 To nb
                    ii = ii + 1
                    ib = ib + 1
                    Nodemb(ii) = ip
                    Kdispmb(ii) = ib
                Next j
            Next ip
        End If

    End Sub

    Private Sub MatrixReduct()
        '行列の縮減
        Dim i, ii As Integer
        Norder = Nall
        ii = 0
        For i = 1 To Nall
            If Nodemb(i) = 0 Then
                Norder = Norder - 1
            Else
                ii = ii + 1
                NodeMatR(ii) = Nodemb(i)
                KdispMatR(ii) = Kdispmb(i)
                RMmatrix(ii) = RMmatb(i)
            End If
        Next i

    End Sub

    Private Sub ReqTime(ByVal crate As Single, ByVal rmesh As Single, _
    ByVal b1 As Single)
        '残りの所要時間の計算
        'crate･･･調整係数
        'rmesh･･･残存ﾒｯｼｭ数
        'b1･･･計算の時間差（秒単位）
        Dim aa$, tima$
        Dim b2 As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics

        tima$ = ""
        If b1 < 0 Then
            b1 = b1 + 86400
        End If
        b2 = b1 * rmesh / crate
        Call TimConv(tima$, b2)
        aa$ = "残り " & tima$
        gr.Clear(Color.White)
        gr.DrawString(aa$, New Font("ＭＳ ゴシック", 9), Brushes.Black, 1, 1)
        gr.Dispose()

    End Sub

    Private Sub Store()
        '全体ﾏﾄﾘｯｸｽへの蓄積
        Dim i, it As Integer
        For i = 1 To Nvar
            it = NPrefer(i)
            If it > 0 Then
                RMmatb(it) = RMmatb(it) + Em(i, i)
            End If
        Next i
    End Sub

    Private Sub TimConv(ByRef tima$, ByVal rsec As Single)
        '秒数から時分秒への換算
        'tima$･･･時分秒表示の時間
        'rsec･･･秒単位の時間
        Dim rhour, rmin As Single
        rhour = Int(rsec / 3600)
        rsec = rsec - rhour * 3600
        rmin = Int(rsec / 60)
        rsec = CInt(rsec + 1 - rmin * 60)
        tima$ = Str$(rhour) + "h" + Str$(rmin) + "min" + Str$(rsec) + "s"

    End Sub

    Private Function TimeLap(ByVal date1 As Date, ByVal date2 As Date) As Single
        '経過時間の計算（1日以内）
        'date1･･･開始時刻
        'date2･･･終了時刻
        Dim sec1, sec2 As Single
        If date1.Date <> date2.Date Then
            sec2 = 3600 * 24
        End If
        sec1 = 3600 * date1.Hour + 60 * date1.Minute + date1.Second
        sec1 = sec1 + 0.001 * date1.Millisecond
        sec2 = sec2 + 3600 * date2.Hour + 60 * date2.Minute + date2.Second
        sec2 = sec2 + 0.001 * date2.Millisecond
        TimeLap = sec2 - sec1

    End Function

    Private Sub TransMatrix(ByVal cs As Single, ByVal cc As Single)
        '座標変換行列の設定
        'cc･･･部材のcosφ
        'cs･･･部材のsinφ
        Dim ii As Integer
        Trans(1, 1) = cc : Trans(1, 2) = cs
        Trans(2, 1) = -cs : Trans(2, 2) = cc
        If Ntype = 1 Then
            ii = 3
        Else
            ii = 4
            Trans(3, 3) = 1
            Trans(6, 6) = 1
        End If
        Trans(ii, ii) = cc : Trans(ii, ii + 1) = cs
        Trans(ii + 1, ii) = -cs : Trans(ii + 1, ii + 1) = cc
    End Sub

    Private Sub BarsVRCal3a_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim aa$, fxb$, timn$
        Dim ib, ic, icount, id, ie, ix, j, k, kb, nb As Integer
        Dim area, df, fwx, rdif, rmesh, rmeshsum, rou, sec, ub As Single
        Dim gr As Graphics = PictureBox1.CreateGraphics
        Dim fnt As Font = New Font("ＭＳ ゴシック", 9)
        Dim myBrush As Brush = New SolidBrush(Color.Black)

        Me.Show()

        Crate = 0.001
        fxb$ = ""
        timn$ = ""
        Call TimCal(0, timn$)

        Label1.Text = "計算実施中！"
        Label2.Text = "しばらくお待ちください。"
        Label3.Text = ""
        Me.Refresh()

        Fw1 = 0 : Fw2 = 100
        fwx = 0

        df = Fw2 / Nelem
        rmeshsum = Nelem   'ﾒｯｼｭ合計

        Call InitialSet1()  '初期設定

        Label3.Text = "質量マトリックスの計算"
        ic = 0
        Application.DoEvents()
        icount = 0
        For ie = 1 To Nelem
            Call ElemMatrix(ie, kb, rou, area)    '要素ﾏﾄﾘｯｸｽの計算
            Call Store()                          '全体ﾏﾄﾘｯｸｽへの蓄積

            '進行表示
            fwx = fwx + df
            ProgressBar1.Value = fwx
            If ic = 9 Then
                rmesh = ie
                Dim timenew As Date = Now
                sec = TimeLap(Timst, timenew)
                rdif = rmeshsum - rmesh
                Call ReqTime(rmesh, rdif, sec)     '残りの所要時間の計算
                ic = 0
            Else
                ic = ic + 1
            End If
            If icount < 99 Then
                icount = icount + 1
            Else
                Application.DoEvents()
                icount = 0
            End If
        Next ie

        If Kboundfree = 0 Then
            '拘束条件処理
            For ib = 1 To Nbound
                ub = 0
                If Ntype < 3 Then
                    j = Ndim * (Nrest(ib) - 1)
                    If Ntype = 1 Then
                        nb = 2
                    Else
                        nb = 3
                    End If
                Else
                    k = Nrest(ib)
                    j = LrD(k) - 1
                    nb = NvarPD(k)
                End If
                For id = 1 To nb
                    If Jdirect(ib, id) > 0 Then
                        k = j + id
                        Nodemb(k) = 0
                    End If
                Next id
            Next ib
        End If

        Application.DoEvents()
        Call MatrixReduct()    '行列の縮減

        gr.Clear(Color.White)

        Call TimCal(1, timn$)   'ﾀｲﾏｰ計算
        aa$ = "END   " & timn$
        Label1.Text = "計算終了！"
        Label2.Text = "ﾏﾄﾘｯｸｽﾃﾞｰﾀを算出しました。"
        Label3.Text = aa$

        aa$ = "質量ﾏﾄﾘｯｸｽを解析用ファイルに保存しますか？"
        Me.BringToFront()
        ix = MsgBox(aa$, 4, "ファイル保存")
        If ix = 6 Then
            KindVEqua = 0
            NPvib = 1
            NLvib = 1
            KAnal = 0
            NvibTime = 1
            ReDim KPvib(1), JLoadVib(1, 3)
            ReDim FLvibTime(1, 1)
            KindLvib = 0
            Call FileName(Fbars$, fxb$)     'ﾌｧｲﾙ名から拡張子なしの部分を取得
            Fm$ = fxb$ + "VR" + ".dat"
            InOut = 1
            Dim frm As Form = New AnalDat6() 'ﾌｧｲﾙへの保存
            frm.Show()
        End If
        Me.Close()

    End Sub
End Class
